from subjectdata.SSheetState import SSheetState
from subjectdata.CellValue import CellValue
import json
import types
import glob
#temporary, waiting getSelected Cell implementation
from subjectdata.CellCoord import CellCoord


def inputText(subject, x, y, data =""):

    try:
      x=int(x)
      y=int(y)
    except Exception,e:
      pass

    cell= CellCoord(x,y)

    errMessage = ""

    if  len(data)>0:
      if data[0]!='=':
        try:
          data=float(data)
        except Exception,e:
          pass
        if type(data)==types.FloatType:
          data="="+str(data)

    state=SSheetState()
    if len(data)>0 and data[0]=='=':
      state.setCellFormula(cell,data)
    else:
      value=CellValue(valueString=data)
      state.setCellValue(cell,value)

    errTuple = subject.setState(state)
    if not errTuple[0]:
      print "A parse error was found in the formula"
      print errTuple[1]
      errMessage = errTuple[1]
      errMessage = errMessage[2:-2]
      print "error message: "+ errMessage
    return errMessage

def copy(subject, xA, yA, xB, yB):

    try:
      xA=int(xA)
      yA=int(yA)
      xB=int(xB)
      yB=int(yB)
    except Exception,e:
      pass

    cellCoordA = CellCoord(xA,yA)
    cellCoordB = CellCoord(xB,yB)
    subject.copy(cellCoordA, cellCoordB)
    return "ok"

def past(subject, xA, yA, xB, yB):

    try:
      xA=int(xA)
      yA=int(yA)
      xB=int(xB)
      yB=int(yB)
    except Exception,e:
      pass

    cellCoordA = CellCoord(xA,yA)
    cellCoordB = CellCoord(xB,yB)
    subject.paste(cellCoordA, cellCoordB)
    return "ok"

def cut(subject, xA, yA, xB, yB):

    copy(subject, xA, yA, xB, yB)
    delete(subject, xA, yA, xB, yB)

    return "ok"

def save(subject, fileName):

    subject.exportToFile("DSheet/prototype4/savedsheets/"+fileName+".ds")
    return "ok"

def load(subject, fileName):

    fileName = "DSheet/prototype4/savedsheets/"+fileName+".ds"
    if(len(glob.glob(fileName))>0):
        if not subject.importFromFile(fileName):
            print "spreadSheet "+fileName+" not found"
            return "not ok"
        else:
            return "ok"
    else:
        return "not ok"


def getFilesToLoad():
    retour = '['
    allFileNames = glob.glob('./DSheet/prototype4/savedsheets/*.ds')
    for fileName in allFileNames:
        fileName = fileName.replace("./DSheet/prototype4/savedsheets/", "");
        fileName = fileName.replace(".ds", "");
        retour += '"'+fileName+'"' + ','
    #the last coma
    retour = retour[:-1]
    retour += ']'
    return retour;

def undo(subject):

    subject.undo()
    return "ok"

def redo(subject):

    subject.redo()
    return "ok"

def delete(subject, xA, yA, xB, yB):

    try:
      xA=int(xA)
      yA=int(yA)
      xB=int(xB)
      yB=int(yB)
    except Exception,e:
      pass

    newState=SSheetState()
    numberCellX= abs(xB-xA)+1
    numberCellY= abs(yB-yA)+1

    xD = min(xA, xB)
    yD = min(yA, yB)

    for i in range(0, numberCellX):
        for j in range(0, numberCellY):
            cellCoord = CellCoord(xD+i, yD+j)
            newState.setCellFormula(cellCoord,"")
    subject.setState(newState)

def storeSubjectDataInJsonOptimised(width, height, cells):


    retour =''
    cellToUpdateX = ', "cellToUpdateX" : ['
    cellToUpdateY = ', "cellToUpdateY" : ['
    values = ''

    dropOne = False
    # we store the value of the cells
    for cell in cells:
      dropOne = True
      value=cell.getValue()
      formula = cell.getFormula()
      cellCoord = cell.getCoords()


      if(cellCoord.col() < width and cellCoord.row() < height):
          y = str(cellCoord.row())
          x = str(cellCoord.col())

          cellToUpdateX += '"'+x+'"'+','
          cellToUpdateY += '"'+y+'"'+','



          # we add the value to cell that has changed
          if value.isFloat():
            #
            values += ','+'"'+x+'!'+y+'": ["'+str(value.getFloat())+'"'
          elif value.isString():
            #
            values +=','+ '"'+x+'!'+y+'": ["'+value.getString()+'"'
          else:
            values +=','+ '"'+x+'!'+y+'": [""'

          values += ', "'+formula+'" ]'


    #there is one ',' in surplus
    if(dropOne):
        cellToUpdateX = cellToUpdateX[:-1]
        cellToUpdateY = cellToUpdateY[:-1]
        dropOne = False

    # we add cellToUpdateX
    # we add cellToUpdateY
    # we add values
    cellToUpdateX += ']'
    cellToUpdateY += ']'
    retour += cellToUpdateX
    retour += cellToUpdateY
    retour += values
    return retour

def getResponseToUpdate(parsed_json, subject, source):
    #get the data from subject
    response = '{'
    clientUpdateTime = int(parsed_json["dateUpdate"])
    [cellsToSend, newClientUpdateTime] = subject.getUpdatedCells(clientUpdateTime)
    response += '"request": "update"'
    width = parsed_json["width"]
    height = parsed_json["height"]
    response += ','+'"width": "'+width+'"'
    response += ','+'"height": "'+height+'"'
    response += ','+'"connectionID": "'+source+'"'
    response += storeSubjectDataInJsonOptimised(int(width), int(height), cellsToSend)
    response += ',' +'"dateUpdate": "'+str(newClientUpdateTime)+'"'
    response += ',' +'"clientName": "'+parsed_json['clientName']+'"'

    if(len(cellsToSend) > 0):
        response += ','+'"update": "yes"'
        response += '}'
        return response, True
    else:
        response += ','+'"update": "no"'
        response += '}'
        return response, False
    #self.response += ',' +'"dateUpdate": "'+str(self.dateUpdate)+'"'
    #self.response += storeSubjectDataInJson(int(width), int(height), self.subject)
