import sys                             # for exit()
from Tkinter          import *         # basic Tkinter
from gui.SSGridView import *
from subjectdata.SSheetData import *
from subjectdata.SubjectManager import SubjectManager

__version__="0.85"

# modified for WebDSheet

class DSheet(SubjectManager):
  def __init__(self, root):
    self.root= root
    self.__subjects=[]
    self.__numSubjects=0
    self.gridView = []
    print "DSheet "+__version__+" released under the GNU General public license"

  def addGridViewObserver(self,
                          subject,
                          rows=100,
                          columns=50,
                          cellHeight=20,
                          cellWidth=65):

    if not subject in self.__subjects:
      return

    gridRoot = Toplevel(self.root) #Tk()
    gridRoot.protocol("WM_DELETE_WINDOW", wmQuit)
    gridRootTitle="DSheet <observing subject "+str(self.__numSubjects)+">  "+__version__
    gridRoot.title(gridRootTitle)

    # we make the link between the view and the subject
    self.gridView = SpreadsheetGridView_Static(subject=subject,
                                          master=gridRoot,
                                          title=gridRootTitle,
                                          height=rows, width=columns,
                                          cellHeight=cellHeight,
                                          cellWidth=cellWidth,
                                          version=__version__)

    subject.attach(self.gridView)

    return self.gridView

  def createSubject(self):
    subject=SSheetData(self, self.__numSubjects)
    self.__subjects.append(subject)
    self.__numSubjects+=1
    return subject

  def removeSubject(self, subject):
    self.__subjects.remove(subject)
    if len(self.__subjects)==0:
      sys.exit()

  def hasNoMoreObservers(self, subject):
    self.removeSubject(subject)

def ctrlCQuit():
  """
  Handle SIGINT signal: exit() application
  """
  # we may wish to put cleanup actions here
  print "Spreadsheet Application was closed (by SIGINT signal)"
  sys.exit()

def wmQuit():
  """
  Handle root window close: exit() application
  """
  # we may wish to put cleanup actions here
  print "Spreadsheet Application was closed (by Window Manager)"
  print "TO DO: close only the window not the server"
  sys.exit()

def rootQuit():
  """
  Handle Quit clicked in root window: exit() application
  """
  # we may wish to put cleanup actions here
  print "Spreadsheet Application was closed (by Quit in root window)"
  sys.exit()

if __name__ == "__main__":
  # root window
  root=Tk()
  root.withdraw()
  mainApp=DSheet(root)
  mainApp.addGridViewObserver(mainApp.createSubject())
  try:
    root.mainloop()
  except KeyboardInterrupt:
    ctrlCQuit()
