""" Visitor interface for Abstract Syntax Trees
    @author: Marc Provost
    @organization: McGill University
    @license: GNU General Public License
    @contact: marc.provost@mail.mcgill.ca    
"""

class ASTVisitor: 
  """ Visitor interface for Abstract Syntax Trees
      @group Visitors: visit*
      @sort: __init__, visit*
  """

  def __init__(self):
    pass

  def visitNumber(self, number):
    """ Visits a Number object
        @param number: The object which is visited
        @type number: L{Number}
    """    
    pass

  def visitCellRef(self, cellRef):
    """ Visits a CellRef object
        @param cellRef: The object which is visited
        @type cellRef: L{CellRef}
    """    
    pass

  def visitFunction(self, function):
    """ Visits a Function object
        @param function: The object which is visited
        @type function: L{Function}
    """
    pass

  def visitRangeRef(self, rangeRef):
    """ Visits a RangeRef object
        @param rangeRef: The object which is visited
        @type rangeRef: L{RangeRef}
    """
    pass




