""" Minimal interface for classes managing several subject
    @author: Marc Provost
    @organization: McGill University
    @license: GNU General Public License
    @contact: marc.provost@mail.mcgill.ca
"""

class SubjectManager:
  """ Minimal interface for classes managing several subject
  """
  
  def createSubject(self):
    """ Create a new subject and return it
        @rtype: L{Subject}
    """
    pass

  def removeSubject(self, subject):
    """ Remove the subject
        @param subject: The subject to remove
        @type subject: L{Subject}
    """
    pass
    
  def hasNoMoreObservers(self, subject):
    """ Action to perform when an subject has no more observers.
        @param subject: The subject to remove
        @type subject: L{Subject}    
    """
    pass