""" A simple Class which manages the cells that have been updated
    @author: Julien Tomezach, Master Student
    @organization: ENSTA Bretagne, french engineering school
    @license: GNU General Public License
    @contact: julien.tomezach@ensta-bretagne.org
"""
import time

from utility.TypeCheckUtility import TypeCheckUtility



typeChecker = TypeCheckUtility.getInstance()

"""TODO: Add a buffer for cellsToSend, so the server doesn't have to re-calculate everything each time
"""
class UpdatedCellsManager:


  def __init__(self):
    """
    """
    self.__updatedCells={}
    self.__updateTime = 0
    self.__current_milli_time = lambda: int(round(time.time() * 1000))

  def push(self, cell):
    """
    """
    from SSheetCell import SSheetCell
    if typeChecker.debug: typeChecker.typeCheck([cell], [SSheetCell])
    print "one cell has been pushed: coord x: "+ str(cell.getCoords().row()) + "y: "+ str(cell.getCoords().col()) +" time "+ str(self.__updateTime)
    self.__updatedCells[cell.getCoords()] = [cell, self.__updateTime]

  def getUpdatedCells(self, clientUpdateTime):
    """
    """
    if typeChecker.debug: typeChecker.typeCheck([clientUpdateTime], [int])

    cellsToSend = []
    newClientUpdateTime = clientUpdateTime
    for coord, case in self.__updatedCells.iteritems():
        if(case[1]>clientUpdateTime):
            newClientUpdateTime = max(newClientUpdateTime, case[1])
            cellsToSend.append(case[0])
    return [cellsToSend, newClientUpdateTime]

  def newUpdate(self):
    """
    """
    self.__updateTime = self.__current_milli_time()
