import sys
from traceback import *
from math import pow
from time import asctime

LOG=0
WARNING=1 
FATAL=2

class Callable:
    def __init__(self, anycallable):
        self.__call__ = anycallable

class ErrorUtility:
  instance=None #private
        
  def __init__(self, debug=1, output=sys.stderr, testing=False):
    if ErrorUtility.instance!=None:
      raise RunTimeError("Singleton ErrorUtility is already instantiated")
    self.__clients=[]
    #output medium
    self.__output=output
    #automatic testing mode (must raise exceptions to assert failure in testsuite)
    self.__testing=testing
  
  def getInstance():
    if ErrorUtility.instance==None:
      ErrorUtility.instance=ErrorUtility()
    return ErrorUtility.instance
  getInstance=Callable(getInstance)
  
  def setOutput(self, output):
    self.__output=output
  
  def getOutput(self):
    return self.__output
  
  def setTesting(self):
    self.__testing=True
  
  def unsetTesting(self):
    self.__testing=False
  
  def exceptionRaised(self, exception, level=FATAL):
    if self.__testing:
      raise exception
    else:
      if level==LOG:
        for client in self.__clients:
          client.handleLOG()
                 
        self.__output.write("LOG: "+str(asctime())+" :\n"+str(exception))
        trace = format_list(extract_stack(limit=4))
        for elem in trace:
          self.__output.write(str(elem))         
      elif level==WARNING:
        for client in self.__clients:
          client.handleWARNING()       
      
        self.__output.write("WARNING: "+str(asctime())+" :\n"+str(exception))
        trace = format_list(extract_stack(limit=4))
        for elem in trace:
          self.__output.write(str(elem))                         
      elif level==FATAL:
        for client in self.__clients:
          client.handleFATAL()    

        self.__output.write("FATAL: "+str(asctime())+" :\n"+str(exception))
        trace = format_list(extract_stack(limit=4))
        for elem in trace:
          self.__output.write(str(elem))                  
        sys.exit(1)   
      else:
        v=ValueError("Unknown error level passed to exceptionRaised")
        self.exceptionRaised(v)
      
  def register(self, client):
    self.__clients.append(client)    
        
      
      

      
  
  
    