

gui = {};



gui.EVENTS = {
	MOUSE_CLICK: 			'click',
	MOUSE_MOVE: 			'mousemove',
	MOUSE_DOWN: 			'mousedown',
	MOUSE_UP: 			'mouseup',
	DBL_CLICK: 			'dblclick',
	KEY_PRESS: 'keypress',
	KEY_DOWN: 'keydown',
	KEY_UP: 'keyup',
	BLUR: 'blur',
};


gui.bind_event = function(source,event,controller,raise_name,port,time_offset) {
	if( port === undefined) port = "ui";
	if( time_offset === undefined ) time_offset = 0.0;


	var args = [];
	switch(event) {
		case gui.EVENTS.MOUSE_CLICK:
		args = function(e) {return [e.clientX, e.clientY]};
		break;

		case gui.EVENTS.MOUSE_MOVE:
		args = function(e) {return [e.clientX, e.clientY]};
		break;

		case gui.EVENTS.MOUSE_DOWN:
		args = function(e) {return [e.clientX, e.clientY]};
		break;

		case gui.EVENTS.MOUSE_UP:
		args = function(e) {return [e.clientX, e.clientY]};
		break;

		case gui.EVENTS.DBL_CLICK:
		args = function(e) {return [e.clientX, e.clientY]};
		break;

		case gui.EVENTS.KEY_PRESS:
			args = function(e) {
				if(e.which == 0){
					return [e.keyCode, e.view];
				}
				else return [e.which, e.view];
			};
			break;

			case gui.EVENTS.KEY_DOWN:
				args = function(e) {
					if(e.which == 0){
						return [e.keyCode, e.view];
					}
					else return [e.which, e.view];
				};
				break;

			case gui.EVENTS.KEY_UP:
				args = function(e) {
					if(e.which == 0){
						return [e.keyCode, e.view];
					}
					else return [e.which, e.view];
				};
				break;

		case gui.EVENTS.BLUR:
			args = function(e){ return 0};
		break;

		default:
		throw 'Unsupported event';
	}

	source.addEventListener(
		event,
		(function (controller, raise_name, port, time_offset) {
			return function(e) {

				gui.addInput(controller, raise_name, port, args, time_offset, e);

			};}
			)(controller, raise_name, port, time_offset));
		};


		gui.addInput = function(controller, raise_name, port, args, time_offset, e){
			if( raise_name =="key_press" && (e.keyCode == 38 || e.keyCode == 40 || e.keyCode == 37 || e.keyCode == 39 || e.keyCode == 32)){
			e.preventDefault();
			e.stopPropagation();
		}
		else{
			// disable in order to still use default short cut
			//e.preventDefault();
			e.stopPropagation();
		}
		//console.log("adding input to port " + port);
			controller.addInput(new Event(raise_name, port, args(e)), time_offset);
		};

		gui.getColBoundary = function(y, sheetOriginY, spreadSheetHeight,
			 cellHeight){
			y = y-sheetOriginY +window.pageYOffset;
			if(y< 0 || y> spreadSheetHeight) return -1;
			else{
				caseNumber = Math.floor(y/cellHeight);
				return (caseNumber-1);
			}
		};
		gui.getRowBoundary = function(x, sheetOriginX, spreadSheetWidth,
			 cellWidth){
			x = x-sheetOriginX +window.pageXOffset;
			if(x< 0 || x> spreadSheetWidth) return -1;
			else{
				caseNumber = Math.floor(x/cellWidth);
				return (caseNumber-1);
			}
		}

		gui.createCanva = function(width, height){
			var paper = Raphael(0, 0, width, height);
			return paper;
		}

		gui.createSheet = function(sheetOriginX, sheetOriginY,spreadSheetWidth,
		spreadSheetHeight, columnsNumber, rowNumber, cellWidth, cellHeight, paper){

			spreadSheet = {};

			spreadSheet.area = paper.rect(sheetOriginX,
				 sheetOriginY, spreadSheetWidth, spreadSheetHeight);
			spreadSheet.backgroundCol = paper.set();
			spreadSheet.backgroundCol.push(
				gui.drawColBackground(sheetOriginX, sheetOriginY, cellWidth,
			cellHeight, columnsNumber, paper) ,
			  gui.drawRowBackground(sheetOriginX, sheetOriginY, cellWidth,
				cellHeight, rowNumber, paper));
			spreadSheet.line = paper.set();
			spreadSheet.line.push(gui.drawColumns(paper, columnsNumber,rowNumber,
				 sheetOriginX, sheetOriginY, cellWidth, cellHeight),
				   gui.drawRows(paper, columnsNumber, rowNumber, sheetOriginX,
					sheetOriginY, cellWidth, cellHeight));
			spreadSheet.letters = paper.set();
			gui.drawColIndex(spreadSheet.letters, columnsNumber, sheetOriginX,
				sheetOriginY, cellWidth, cellHeight, paper);
			gui.drawRowIndex(spreadSheet.letters, rowNumber, sheetOriginX,
				sheetOriginY, cellWidth, cellHeight, paper);


			return spreadSheet;
		}

		gui.moveElement = function(element, x, y){
			element.transform("T"+x+","+y);
		}
		gui.createSelectedCell = function(sheetOriginX, sheetOriginY, cellWidth,
			cellHeight, paper){
			var cell = paper.rect(sheetOriginX+cellWidth,
				 sheetOriginY+cellHeight, cellWidth, cellHeight);
			cell.attr({stroke:'#210AAB',"stroke-width":3});
			//cell.glow({color: '#210AAB',width: 4}); //doesn't moove
			return cell;
		}
		gui.drawColBackground = function(sheetOriginX, sheetOriginY, cellWidth,
		cellHeight, columnsNumber, paper){
			return paper.rect(sheetOriginX, sheetOriginY,
				 cellWidth*(columnsNumber+1), cellHeight)
			.attr({stroke: "none", fill: "#4FAB9E", opacity: 0.5});
		}
		gui.drawRowBackground = function(sheetOriginX, sheetOriginY, cellWidth,
		cellHeight, rowNumber, paper){
			return paper.rect(sheetOriginX, sheetOriginY,
				 cellWidth, cellHeight*(rowNumber+1))
			.attr({stroke: "none", fill: "#4FAB9E", opacity: 0.5});
		}
		gui.drawColIndex = function(area, columnsNumber, sheetOriginX,
			sheetOriginY, cellWidth, cellHeight, paper){
			for (i = 0; i < columnsNumber; i++) {
				area.push(paper.text(sheetOriginX+(i+1)*cellWidth
				+cellWidth/2,sheetOriginY+cellHeight/2,
				gui.intIndexToStringIndex(i))
				.attr({"font-size": "12px", "font-weight": "800", fill: "dark"}));
			}
		}
		gui.drawRowIndex = function(area, rowNumber, sheetOriginX,
			sheetOriginY, cellWidth, cellHeight, paper){
			for (i = 0; i < rowNumber; i++) {
				area.push(paper.text(sheetOriginX+cellWidth/2,
					sheetOriginY+(i+1)*cellHeight+cellHeight/2,i+1)
				.attr({"font-size": "12px", "font-weight": "800", fill: "dark"}));
			}
		}
		gui.intIndexToStringIndex = function(index){
			var letterNumber = Math.floor(index/26)+1;
			var s = "";
			var chr = "";
			for(j = 0; j< letterNumber; j++){
				chr = String.fromCharCode(97 + (index+j)%26);
				s = s + chr;
			}
			return s;
		}


		gui.drawColumns = function(paper, columnsNumber, rowNumber, sheetOriginX,
		sheetOriginY, cellWidth, cellHeight){
			var xO;
			var yO;
			var xE;
			var yE;

			var columns = paper.set();
			for (i = 0; i <= columnsNumber+1; i++) {
				xO = sheetOriginX+cellWidth*i;
				yO = sheetOriginY;
				xE = xO;
				yE = yO+cellHeight*(rowNumber+1);
				columns.push(paper.path( ["M", xO, yO, "L", xE, yE ] ));
			}
			return columns;
		}

		gui.drawRows = function(paper, columnsNumber, rowNumber, sheetOriginX,
		sheetOriginY, cellWidth, cellHeight){
			var xO;
			var yO;
			var xE;
			var yE;
			var rows = paper.set();
			for (i = 0; i <= rowNumber+1; i++) {
				xO = sheetOriginX;
				yO = sheetOriginY+cellHeight*i;
				xE = xO+cellWidth*(columnsNumber+1);
				yE = yO;
				rows.push(paper.path( ["M", xO, yO, "L", xE, yE ] ));

			}

			return rows;

		}

		gui.isIn = function(x, y, xBoundary, yBoundary, width, height){
			//TODO switch to absolute value.
			var x = x-10-40;
			var y = y-10-25-30;
			var cond1 = x>xBoundary && y>yBoundary;
			var cond2 = x<xBoundary+width && y<yBoundary+height;

			return cond1 && cond2;
		}


		gui.updateCell = function (paper,text, x, y, allText){
			var key = x+'!'+y;
			var offset = 10;
			if(allText.hasOwnProperty(key)){
				allText[key].attr({'text': text});
			}
			else{
			allText[key] = paper.text(x+50+5, y+65+(20-12), "");
			allText[key].attr({'text': text,'text-anchor': 'start', 'font-size': '12px'});
			}
		}

		gui.createEditTextInput = function(paper, x, y, allText){
			var key = x+'!'+y;
			if(allText.hasOwnProperty(key)){
				var text = allText[key].attr('text');
				text = text +'|';
				allText[key].attr({'text': text});
				return [text.length-1,allText[key]];
			}
			else{
			textSVG = paper.text(x+50+5, y+65+(20-12), "|");
			textSVG.attr({'text-anchor': 'start', 'font-size': '12px'});
			return [0,textSVG];
		}
		}

		gui.editTextInput = function(text, textSVG, cursorPos){

			var oldText = textSVG.attr('text');
			var parts = oldText.split("|");
			var partOne = parts[0];
			var partTwo = "";
			if(parts.length == 2) partTwo = parts[1];
			var newText = partOne + text + '|' + partTwo;
			textSVG.attr("text", newText);
			cursorPos +=1;
			return cursorPos;
		}

		gui.getText = function(textSVG){
			var oldText = textSVG.attr('text');
			oldText = oldText.replace(' ->', '');
			oldText = oldText.replace('<- ', '');
			var parts = oldText.split("|");
			var newText = parts[0];
			if(parts.length == 2) newText += parts[1];
			return newText;

		}

		// I could not explain why I had to add +1 to cursorPos ...
		gui.mooveCursor = function(textSVG, cursorPos,translate){


			var oldText = textSVG.attr('text');
			if((cursorPos >= (oldText.length-1) && translate >0) || (cursorPos <=0 && translate<0)){
				return cursorPos;
			}

			var parts = oldText.split("|");
			var partOne = parts[0];
			var partTwo = "";
			if(parts.length == 2) partTwo = parts[1];
			oldText = partOne + partTwo;
			cursorPos = cursorPos+ translate+1;
			var partOneB = oldText.substr(0, cursorPos-1);
			if(cursorPos == 1) var partTwoB = oldText;
			else var partTwoB = oldText.substr(cursorPos-1, oldText.length-1);
			var newText = partOneB+'|'+partTwoB;
			textSVG.attr("text", newText);
			cursorPos = newText.indexOf('|');
			return cursorPos;

		}
		gui.deleteLastElementBeforeCursor = function(textSVG, cursorPos){

			cursorPos = gui.mooveCursor(textSVG, cursorPos,-1);
			var text = textSVG.attr('text');
			if(cursorPos != 0) text = text.substr(0, cursorPos) +'|'+text.substr(cursorPos+2, text.length-1);
			else text = '|';
			textSVG.attr("text", text);
			cursorPos = text.indexOf('|');
			return cursorPos;
		}

		gui.removeElement = function(element){
				if(!jQuery.isEmptyObject(element)){
			element.remove();
		}
		}

		// return the text
		gui.drawFormulaCell = function(paper, x, y){
			// this offset is due to when we change the text with attribute an offset
			// appears on the screen
				var offset = 10;
				paper.rect(x, y, 80, 20);
				var t = paper.text(x+10+offset,y+10, "");
				return t;
		}

		gui.drawAreaSelectedCells = function(paper, xA, yA, xB, yB, cellWidth, cellHeight, rectangle){
				if(!jQuery.isEmptyObject(rectangle)){
					rectangle.remove();
				}
					var widthRect = (Math.abs(xA-xB)+1)*cellWidth;
					var heightRect = (Math.abs(yA-yB)+1)*cellHeight;

					var xD = Math.min(xA, xB);
					var yD = Math.min(yA, yB);

					rectangle = paper.rect(xD*cellWidth+50, yD*cellHeight+65, widthRect, heightRect);
					rectangle.attr({stroke: "none", fill: "#4FAB9E", opacity: 0.5});
					return rectangle;

		}

		gui.drawSysInfoCell = function(paper, x, y, width, height){
			texts = {}
			var offset = 15;
			paper.rect(x, y, width, height);
			var t = paper.text(x+10+offset,y+10, "");
			texts['idSocket'] = t;
			t = paper.text(x+10+offset,y+30, "");
			texts['clientName'] = t;
			return texts;

		}

		// to cancel or big work to continue it
		gui.putErrorRed = function(text){
			// get the error
			var error;
			var newText = text;
			var a = text.indexOf(" ->");
			if (a == -1)
				error= '';
			var b = text.indexOf("<- ");
			if (b == -1)
				error= '';
			if(a!= -1 && b!=-1){
				error = text.substr(a+3, b-a-3);
				console.log(error);
				//remove the delimiter
				text = text.replace(/ ->/g,'');
				text = text.replace(/<- /g,'');

				var c = text.indexOf(error);
				var partOne = text.substr(0, c);
				console.log(partOne);
				var partTwo = text.substr(c+error.length, text.length-1);
				console.log(partTwo);

				//newText= partOne +'<span style="color:#AB070E">'+error+'</span>'+ partTwo

		}
		return newText;
		}

		gui.changeColorCell = function(cell, color){
			if(color == "red")
			cell.attr({stroke:'#AB070E',"stroke-width":3});
			if(color == "blue")
			cell.attr({stroke:'#210AAB',"stroke-width":3});
		}
