/* Generated by Statechart compiler by Glenn De Jonghe, Joeri Exelmans, Simon Van Mierlo, and Yentl Van Tendeloo (for the inspiration)

Date:   Sun Sep  4 17:46:23 2016

Model author: Julien Tomezach 
Model name:   DSheet_GUI
Model description:
Web GUI of DSheet*/


// package "DSheet_GUI"
var DSheet_GUI = {};
(function() {

var MainWindow = function(controller) {
    RuntimeClassBase.call(this, controller);
    
    this.semantics.big_step_maximality = StatechartSemantics.TakeMany;
    this.semantics.internal_event_lifeline = StatechartSemantics.Queue;
    this.semantics.input_event_lifeline = StatechartSemantics.FirstComboStep;
    this.semantics.priority = StatechartSemantics.SourceParent;
    this.semantics.concurrency = StatechartSemantics.Single;
    
    // build Statechart structure
    this.build_statechart_structure();
    
    // user defined attributes
    this.mainField = null;
    this.formulaBarHeight = null;
    this.cellWidth = null;
    this.cellHeight = null;
    this.columnsNumber = null;
    this.rowNumber = null;
    this.sheetOriginX = null;
    this.sheetOriginY = null;
    this.spreadSheetWidth = null;
    this.spreadSheetHeight = null;
    this.screenWidth = null;
    this.screenHeight = null;
    
    // call user defined constructor
    MainWindow.prototype.user_defined_constructor.call(this);
};
MainWindow.prototype = new Object();
(function() {
    var proto = new RuntimeClassBase();
    for (prop in proto) {
        MainWindow.prototype[prop] = proto[prop];
    }
})();

MainWindow.prototype.user_defined_constructor = function() {
    this.topBarX = 10;
    this.topBarY = 10;
    this.topBarHeight = 40;
    
    this.formulaBarX = 10;
    this.formulaBarY = this.topBarY+this.topBarHeight+5;
    this.formulaBarHeight = 20;
    
    this.cellWidth = 55;
    this.cellHeight = 35;
    this.columnsNumber = 26;
    this.rowNumber = 20;
    
    this.spreadSheetWidth = (this.columnsNumber+1)*this.cellWidth;
    this.spreadSheetHeight = (this.rowNumber+1)*this.cellHeight;
    
    this.sheetOriginX = 0;
    this.sheetOriginY = 10+ this.formulaBarHeight+this.formulaBarY;
    
    this.screenWidth = screen.width-10-25;
    this.screenHeight = screen.height-10-5;
    
    var mainFieldWidth = Math.max(screen.width, this.spreadSheetWidth+this.sheetOriginX);
    var mainFieldHeight = Math.max(screen.height, this.spreadSheetHeight+this.sheetOriginY);
    
    this.mainField = gui.createCanva(mainFieldWidth, mainFieldHeight);
};

MainWindow.prototype.user_defined_destructor = function() {
};


// builds Statechart structure
MainWindow.prototype.build_statechart_structure = function() {
    
    // state <root>
    this.states[""] = new State(0, this);
    
    // state /initializing
    this.states["/initializing"] = new State(1, this);
    this.states["/initializing"].setEnter(this._initializing_enter);
    this.states["/initializing"].setExit(this._initializing_exit);
    
    // state /creating_messenger
    this.states["/creating_messenger"] = new State(2, this);
    
    // state /creating_wFormula
    this.states["/creating_wFormula"] = new State(3, this);
    
    // state /creating_spreadsheet
    this.states["/creating_spreadsheet"] = new State(4, this);
    
    // state /creating_topBar
    this.states["/creating_topBar"] = new State(5, this);
    
    // state /running
    this.states["/running"] = new State(6, this);
    
    // add children
    this.states[""].addChild(this.states["/initializing"]);
    this.states[""].addChild(this.states["/creating_messenger"]);
    this.states[""].addChild(this.states["/creating_wFormula"]);
    this.states[""].addChild(this.states["/creating_spreadsheet"]);
    this.states[""].addChild(this.states["/creating_topBar"]);
    this.states[""].addChild(this.states["/running"]);
    this.states[""].fixTree();
    this.states[""].default_state = this.states["/initializing"];
    
    // transition /initializing
    var _initializing_0 = new Transition(this, this.states["/initializing"], [this.states["/creating_messenger"]]);
    _initializing_0.setAction(this._initializing_0_exec);
    _initializing_0.trigger = new Event("_0after");
    this.states["/initializing"].addTransition(_initializing_0);
    
    // transition /creating_messenger
    var _creating_messenger_0 = new Transition(this, this.states["/creating_messenger"], [this.states["/creating_wFormula"]]);
    _creating_messenger_0.setAction(this._creating_messenger_0_exec);
    _creating_messenger_0.trigger = new Event("instance_created", null);
    this.states["/creating_messenger"].addTransition(_creating_messenger_0);
    
    // transition /creating_wFormula
    var _creating_wFormula_0 = new Transition(this, this.states["/creating_wFormula"], [this.states["/creating_spreadsheet"]]);
    _creating_wFormula_0.setAction(this._creating_wFormula_0_exec);
    _creating_wFormula_0.trigger = new Event("instance_created", null);
    this.states["/creating_wFormula"].addTransition(_creating_wFormula_0);
    
    // transition /creating_spreadsheet
    var _creating_spreadsheet_0 = new Transition(this, this.states["/creating_spreadsheet"], [this.states["/creating_topBar"]]);
    _creating_spreadsheet_0.setAction(this._creating_spreadsheet_0_exec);
    _creating_spreadsheet_0.trigger = new Event("instance_created", null);
    this.states["/creating_spreadsheet"].addTransition(_creating_spreadsheet_0);
    
    // transition /creating_topBar
    var _creating_topBar_0 = new Transition(this, this.states["/creating_topBar"], [this.states["/running"]]);
    _creating_topBar_0.setAction(this._creating_topBar_0_exec);
    _creating_topBar_0.trigger = new Event("instance_created", null);
    this.states["/creating_topBar"].addTransition(_creating_topBar_0);
};

MainWindow.prototype._initializing_enter = function() {
    this.addTimer(0, 0.1);
};

MainWindow.prototype._initializing_exit = function() {
    this.removeTimer(0);
};

MainWindow.prototype._initializing_0_exec = function(parameters) {
    this.big_step.outputEventOM(new Event("create_instance", null, [this, "messenger", "Messenger", this.columnsNumber, this.rowNumber]));
};

MainWindow.prototype._creating_messenger_0_exec = function(parameters) {
    var association_name = parameters[0];
    this.big_step.outputEventOM(new Event("start_instance", null, [this, association_name]));
    this.big_step.outputEventOM(new Event("create_instance", null, [this, "wFormula", "WFormula", this.formulaBarX, this.formulaBarY, this.formulaBarHeight, this.screenWidth, this.mainField]));
};

MainWindow.prototype._creating_wFormula_0_exec = function(parameters) {
    var association_name = parameters[0];
    this.big_step.outputEventOM(new Event("start_instance", null, [this, association_name]));
    this.big_step.outputEventOM(new Event("create_instance", null, [this, "spreadSheet", "SpreadSheet", this.cellWidth, this.cellHeight, this.columnsNumber, this.rowNumber, this.sheetOriginX, this.sheetOriginY, this.spreadSheetWidth, this.spreadSheetHeight, this.mainField]));
};

MainWindow.prototype._creating_spreadsheet_0_exec = function(parameters) {
    var association_name = parameters[0];
    this.big_step.outputEventOM(new Event("start_instance", null, [this, association_name]));
    this.big_step.outputEventOM(new Event("create_instance", null, [this, "topBar", "TopBar", this.topBarX, this.topBarY, this.topBarHeight, this.screenWidth, this.mainField]));
};

MainWindow.prototype._creating_topBar_0_exec = function(parameters) {
    var association_name = parameters[0];
    this.big_step.outputEventOM(new Event("start_instance", null, [this, association_name]));
};

MainWindow.prototype.initializeStatechart = function() {
    // enter default state
    var states = this.states["/initializing"].getEffectiveTargetStates();
    this.updateConfiguration(states);
    for (var state_idx in states) {
        if (!states.hasOwnProperty(state_idx)) continue;
        var state = states[state_idx]
        if (state.enter) {
            state.enter();
        }
    }
};

// add symbol 'MainWindow' to package 'DSheet_GUI'
DSheet_GUI.MainWindow = MainWindow;

var WFormula = function(controller, formulaBarX, formulaBarY, formulaBarHeight, screenWidth, mainField) {
    RuntimeClassBase.call(this, controller);
    
    this.semantics.big_step_maximality = StatechartSemantics.TakeMany;
    this.semantics.internal_event_lifeline = StatechartSemantics.Queue;
    this.semantics.input_event_lifeline = StatechartSemantics.FirstComboStep;
    this.semantics.priority = StatechartSemantics.SourceParent;
    this.semantics.concurrency = StatechartSemantics.Single;
    
    // build Statechart structure
    this.build_statechart_structure();
    
    // call user defined constructor
    WFormula.prototype.user_defined_constructor.call(this, formulaBarX, formulaBarY, formulaBarHeight, screenWidth, mainField);
};
WFormula.prototype = new Object();
(function() {
    var proto = new RuntimeClassBase();
    for (prop in proto) {
        WFormula.prototype[prop] = proto[prop];
    }
})();

WFormula.prototype.user_defined_constructor = function(formulaBarX, formulaBarY, formulaBarHeight, screenWidth, mainField) {
    this.x = formulaBarX;
    this.y = formulaBarY;
    this.formulaBarHeight = formulaBarHeight;
    this.formulaBarWidth = screenWidth;
    this.mainField = mainField;
    this.text = {};
    this.formulas = {};
};

WFormula.prototype.user_defined_destructor = function() {
};


// builds Statechart structure
WFormula.prototype.build_statechart_structure = function() {
    
    // state <root>
    this.states[""] = new State(0, this);
    
    // state /draw_widget
    this.states["/draw_widget"] = new State(1, this);
    this.states["/draw_widget"].setEnter(this._draw_widget_enter);
    this.states["/draw_widget"].setExit(this._draw_widget_exit);
    
    // state /waiting_to_update
    this.states["/waiting_to_update"] = new State(2, this);
    
    // add children
    this.states[""].addChild(this.states["/draw_widget"]);
    this.states[""].addChild(this.states["/waiting_to_update"]);
    this.states[""].fixTree();
    this.states[""].default_state = this.states["/draw_widget"];
    
    // transition /draw_widget
    var _draw_widget_0 = new Transition(this, this.states["/draw_widget"], [this.states["/waiting_to_update"]]);
    _draw_widget_0.setAction(this._draw_widget_0_exec);
    _draw_widget_0.trigger = new Event("_0after");
    this.states["/draw_widget"].addTransition(_draw_widget_0);
    
    // transition /waiting_to_update
    var _waiting_to_update_0 = new Transition(this, this.states["/waiting_to_update"], [this.states["/waiting_to_update"]]);
    _waiting_to_update_0.setAction(this._waiting_to_update_0_exec);
    _waiting_to_update_0.trigger = new Event("cell_moved", null);
    this.states["/waiting_to_update"].addTransition(_waiting_to_update_0);
    var _waiting_to_update_1 = new Transition(this, this.states["/waiting_to_update"], [this.states["/waiting_to_update"]]);
    _waiting_to_update_1.setAction(this._waiting_to_update_1_exec);
    _waiting_to_update_1.trigger = new Event("new_formula", null);
    this.states["/waiting_to_update"].addTransition(_waiting_to_update_1);
};

WFormula.prototype._draw_widget_enter = function() {
    this.addTimer(0, 0.1);
};

WFormula.prototype._draw_widget_exit = function() {
    this.removeTimer(0);
};

WFormula.prototype._draw_widget_0_exec = function(parameters) {
    this.text = gui.drawFormulaCell(this.mainField, this.x, this.y, this.formulaBarHeight, this.formulaBarWidth);
};

WFormula.prototype._waiting_to_update_0_exec = function(parameters) {
    var x = parameters[0];
    var y = parameters[1];
    var key = x+'!'+y;
    var textFormula = "";
    if(this.formulas.hasOwnProperty(key)){
    	textFormula =this.formulas[key];
    }
    this.text.attr('text', textFormula);
};

WFormula.prototype._waiting_to_update_1_exec = function(parameters) {
    var x = parameters[0];
    var y = parameters[1];
    var formula = parameters[2];
    var key = x+'!'+y;
    this.formulas[key] = formula;
};

WFormula.prototype.initializeStatechart = function() {
    // enter default state
    var states = this.states["/draw_widget"].getEffectiveTargetStates();
    this.updateConfiguration(states);
    for (var state_idx in states) {
        if (!states.hasOwnProperty(state_idx)) continue;
        var state = states[state_idx]
        if (state.enter) {
            state.enter();
        }
    }
};

// add symbol 'WFormula' to package 'DSheet_GUI'
DSheet_GUI.WFormula = WFormula;

var TopBar = function(controller, topBarX, topBarY, topBarHeight, screenWidth, mainField) {
    RuntimeClassBase.call(this, controller);
    
    this.semantics.big_step_maximality = StatechartSemantics.TakeMany;
    this.semantics.internal_event_lifeline = StatechartSemantics.Queue;
    this.semantics.input_event_lifeline = StatechartSemantics.FirstComboStep;
    this.semantics.priority = StatechartSemantics.SourceParent;
    this.semantics.concurrency = StatechartSemantics.Single;
    
    // build Statechart structure
    this.build_statechart_structure();
    
    // call user defined constructor
    TopBar.prototype.user_defined_constructor.call(this, topBarX, topBarY, topBarHeight, screenWidth, mainField);
};
TopBar.prototype = new Object();
(function() {
    var proto = new RuntimeClassBase();
    for (prop in proto) {
        TopBar.prototype[prop] = proto[prop];
    }
})();

TopBar.prototype.user_defined_constructor = function(topBarX, topBarY, topBarHeight, screenWidth, mainField) {
    //Disconnect
    this.disconnectHeight = 10;
    
    //TopBar
    this.topBarX = topBarX;
    this.topBarY = topBarY + this.disconnectHeight;
    this.topBarHeight = topBarHeight-this.disconnectHeight;
    this.mainField = mainField;
    this.screenWidth = screenWidth;
    
    //Menu
    this.firstSquareWidth = 40;
    this.textsTopBar = {};
    this.textsMenu = ["save", "load"];
    this.menuHeight = 20;
    this.menuDisplayed = false;
    
    
    
    //save and load
    this.subMenuWidget ={}
    this.cursorPos = 0;
    this.svgText = {};
    
    //files to load
    this.filesToLoadWindow = {};
};

TopBar.prototype.user_defined_destructor = function() {
};


// builds Statechart structure
TopBar.prototype.build_statechart_structure = function() {
    
    // state <root>
    this.states[""] = new State(0, this);
    
    // state /draw_widget
    this.states["/draw_widget"] = new State(1, this);
    this.states["/draw_widget"].setEnter(this._draw_widget_enter);
    this.states["/draw_widget"].setExit(this._draw_widget_exit);
    
    // state /main
    this.states["/main"] = new State(2, this);
    
    // state /main/waiting_click
    this.states["/main/waiting_click"] = new State(3, this);
    
    // state /main/displaying_error_load
    this.states["/main/displaying_error_load"] = new State(4, this);
    this.states["/main/displaying_error_load"].setEnter(this._main_displaying_error_load_enter);
    this.states["/main/displaying_error_load"].setExit(this._main_displaying_error_load_exit);
    
    // state /main/displaying_disconnected
    this.states["/main/displaying_disconnected"] = new State(5, this);
    this.states["/main/displaying_disconnected"].setEnter(this._main_displaying_disconnected_enter);
    this.states["/main/displaying_disconnected"].setExit(this._main_displaying_disconnected_exit);
    
    // state /main/menu_displayed
    this.states["/main/menu_displayed"] = new State(6, this);
    
    // state /main/saving
    this.states["/main/saving"] = new State(7, this);
    
    // state /main/loading
    this.states["/main/loading"] = new ParallelState(8, this);
    
    // state /main/loading/editing
    this.states["/main/loading/editing"] = new State(9, this);
    
    // state /main/loading/editing/editing
    this.states["/main/loading/editing/editing"] = new State(10, this);
    
    // state /main/loading/show_files_to_load
    this.states["/main/loading/show_files_to_load"] = new State(11, this);
    
    // state /main/loading/show_files_to_load/not_showing
    this.states["/main/loading/show_files_to_load/not_showing"] = new State(12, this);
    
    // state /main/loading/show_files_to_load/showing
    this.states["/main/loading/show_files_to_load/showing"] = new State(13, this);
    
    // state /editing_elsewhere
    this.states["/editing_elsewhere"] = new State(14, this);
    
    // state /ctrl_pressing
    this.states["/ctrl_pressing"] = new State(15, this);
    
    // state /ctrl_alt_pressing
    this.states["/ctrl_alt_pressing"] = new State(16, this);
    
    // add children
    this.states[""].addChild(this.states["/draw_widget"]);
    this.states[""].addChild(this.states["/main"]);
    this.states[""].addChild(this.states["/editing_elsewhere"]);
    this.states[""].addChild(this.states["/ctrl_pressing"]);
    this.states[""].addChild(this.states["/ctrl_alt_pressing"]);
    this.states["/main"].addChild(this.states["/main/waiting_click"]);
    this.states["/main"].addChild(this.states["/main/displaying_error_load"]);
    this.states["/main"].addChild(this.states["/main/displaying_disconnected"]);
    this.states["/main"].addChild(this.states["/main/menu_displayed"]);
    this.states["/main"].addChild(this.states["/main/saving"]);
    this.states["/main"].addChild(this.states["/main/loading"]);
    this.states["/main/loading"].addChild(this.states["/main/loading/editing"]);
    this.states["/main/loading"].addChild(this.states["/main/loading/show_files_to_load"]);
    this.states["/main/loading/editing"].addChild(this.states["/main/loading/editing/editing"]);
    this.states["/main/loading/show_files_to_load"].addChild(this.states["/main/loading/show_files_to_load/not_showing"]);
    this.states["/main/loading/show_files_to_load"].addChild(this.states["/main/loading/show_files_to_load/showing"]);
    this.states[""].fixTree();
    this.states[""].default_state = this.states["/draw_widget"];
    this.states["/main"].default_state = this.states["/main/waiting_click"];
    this.states["/main/loading/editing"].default_state = this.states["/main/loading/editing/editing"];
    this.states["/main/loading/show_files_to_load"].default_state = this.states["/main/loading/show_files_to_load/not_showing"];
    
    // transition /draw_widget
    var _draw_widget_0 = new Transition(this, this.states["/draw_widget"], [this.states["/main/waiting_click"]]);
    _draw_widget_0.setAction(this._draw_widget_0_exec);
    _draw_widget_0.trigger = new Event("_0after");
    this.states["/draw_widget"].addTransition(_draw_widget_0);
    
    // transition /main/waiting_click
    var _main_waiting_click_0 = new Transition(this, this.states["/main/waiting_click"], [this.states["/ctrl_pressing"]]);
    _main_waiting_click_0.trigger = new Event("key_down", "ui");
    _main_waiting_click_0.setGuard(this._main_waiting_click_0_guard);
    this.states["/main/waiting_click"].addTransition(_main_waiting_click_0);
    var _main_waiting_click_1 = new Transition(this, this.states["/main/waiting_click"], [this.states["/main/waiting_click"]]);
    _main_waiting_click_1.setAction(this._main_waiting_click_1_exec);
    _main_waiting_click_1.trigger = new Event("update_connectionID", null);
    this.states["/main/waiting_click"].addTransition(_main_waiting_click_1);
    var _main_waiting_click_2 = new Transition(this, this.states["/main/waiting_click"], [this.states["/main/menu_displayed"]]);
    _main_waiting_click_2.setAction(this._main_waiting_click_2_exec);
    _main_waiting_click_2.trigger = new Event("mouse_down", "ui");
    _main_waiting_click_2.setGuard(this._main_waiting_click_2_guard);
    this.states["/main/waiting_click"].addTransition(_main_waiting_click_2);
    var _main_waiting_click_3 = new Transition(this, this.states["/main/waiting_click"], [this.states["/main/displaying_error_load"]]);
    _main_waiting_click_3.setAction(this._main_waiting_click_3_exec);
    _main_waiting_click_3.trigger = new Event("errorLoad", null);
    this.states["/main/waiting_click"].addTransition(_main_waiting_click_3);
    var _main_waiting_click_4 = new Transition(this, this.states["/main/waiting_click"], [this.states["/main/displaying_disconnected"]]);
    _main_waiting_click_4.setAction(this._main_waiting_click_4_exec);
    _main_waiting_click_4.trigger = new Event("disconnected", null);
    this.states["/main/waiting_click"].addTransition(_main_waiting_click_4);
    
    // transition /main/displaying_error_load
    var _main_displaying_error_load_0 = new Transition(this, this.states["/main/displaying_error_load"], [this.states["/main/waiting_click"]]);
    _main_displaying_error_load_0.setAction(this._main_displaying_error_load_0_exec);
    _main_displaying_error_load_0.trigger = new Event("_1after");
    this.states["/main/displaying_error_load"].addTransition(_main_displaying_error_load_0);
    
    // transition /main/displaying_disconnected
    var _main_displaying_disconnected_0 = new Transition(this, this.states["/main/displaying_disconnected"], [this.states["/main/waiting_click"]]);
    _main_displaying_disconnected_0.setAction(this._main_displaying_disconnected_0_exec);
    _main_displaying_disconnected_0.trigger = new Event("_2after");
    this.states["/main/displaying_disconnected"].addTransition(_main_displaying_disconnected_0);
    
    // transition /main/menu_displayed
    var _main_menu_displayed_0 = new Transition(this, this.states["/main/menu_displayed"], [this.states["/main/saving"]]);
    _main_menu_displayed_0.setAction(this._main_menu_displayed_0_exec);
    _main_menu_displayed_0.trigger = new Event("mouse_down", "ui");
    _main_menu_displayed_0.setGuard(this._main_menu_displayed_0_guard);
    this.states["/main/menu_displayed"].addTransition(_main_menu_displayed_0);
    var _main_menu_displayed_1 = new Transition(this, this.states["/main/menu_displayed"], [this.states["/main/loading"]]);
    _main_menu_displayed_1.setAction(this._main_menu_displayed_1_exec);
    _main_menu_displayed_1.trigger = new Event("mouse_down", "ui");
    _main_menu_displayed_1.setGuard(this._main_menu_displayed_1_guard);
    this.states["/main/menu_displayed"].addTransition(_main_menu_displayed_1);
    var _main_menu_displayed_2 = new Transition(this, this.states["/main/menu_displayed"], [this.states["/main/waiting_click"]]);
    _main_menu_displayed_2.setAction(this._main_menu_displayed_2_exec);
    _main_menu_displayed_2.trigger = new Event("mouse_down", "ui");
    _main_menu_displayed_2.setGuard(this._main_menu_displayed_2_guard);
    this.states["/main/menu_displayed"].addTransition(_main_menu_displayed_2);
    
    // transition /main/saving
    var _main_saving_0 = new Transition(this, this.states["/main/saving"], [this.states["/main/saving"]]);
    _main_saving_0.setAction(this._main_saving_0_exec);
    _main_saving_0.trigger = new Event("key_press", "ui");
    _main_saving_0.setGuard(this._main_saving_0_guard);
    this.states["/main/saving"].addTransition(_main_saving_0);
    var _main_saving_1 = new Transition(this, this.states["/main/saving"], [this.states["/main/saving"]]);
    _main_saving_1.setAction(this._main_saving_1_exec);
    _main_saving_1.trigger = new Event("key_press", "ui");
    _main_saving_1.setGuard(this._main_saving_1_guard);
    this.states["/main/saving"].addTransition(_main_saving_1);
    var _main_saving_2 = new Transition(this, this.states["/main/saving"], [this.states["/main/saving"]]);
    _main_saving_2.setAction(this._main_saving_2_exec);
    _main_saving_2.trigger = new Event("key_press", "ui");
    _main_saving_2.setGuard(this._main_saving_2_guard);
    this.states["/main/saving"].addTransition(_main_saving_2);
    var _main_saving_3 = new Transition(this, this.states["/main/saving"], [this.states["/main/saving"]]);
    _main_saving_3.setAction(this._main_saving_3_exec);
    _main_saving_3.trigger = new Event("key_press", "ui");
    _main_saving_3.setGuard(this._main_saving_3_guard);
    this.states["/main/saving"].addTransition(_main_saving_3);
    var _main_saving_4 = new Transition(this, this.states["/main/saving"], [this.states["/main/waiting_click"]]);
    _main_saving_4.setAction(this._main_saving_4_exec);
    _main_saving_4.trigger = new Event("key_press", "ui");
    _main_saving_4.setGuard(this._main_saving_4_guard);
    this.states["/main/saving"].addTransition(_main_saving_4);
    
    // transition /main/loading/editing/editing
    var _main_loading_editing_editing_0 = new Transition(this, this.states["/main/loading/editing/editing"], [this.states["/main/loading/editing/editing"]]);
    _main_loading_editing_editing_0.setAction(this._main_loading_editing_editing_0_exec);
    _main_loading_editing_editing_0.trigger = new Event("key_press", "ui");
    _main_loading_editing_editing_0.setGuard(this._main_loading_editing_editing_0_guard);
    this.states["/main/loading/editing/editing"].addTransition(_main_loading_editing_editing_0);
    var _main_loading_editing_editing_1 = new Transition(this, this.states["/main/loading/editing/editing"], [this.states["/main/loading/editing/editing"]]);
    _main_loading_editing_editing_1.setAction(this._main_loading_editing_editing_1_exec);
    _main_loading_editing_editing_1.trigger = new Event("key_press", "ui");
    _main_loading_editing_editing_1.setGuard(this._main_loading_editing_editing_1_guard);
    this.states["/main/loading/editing/editing"].addTransition(_main_loading_editing_editing_1);
    var _main_loading_editing_editing_2 = new Transition(this, this.states["/main/loading/editing/editing"], [this.states["/main/loading/editing/editing"]]);
    _main_loading_editing_editing_2.setAction(this._main_loading_editing_editing_2_exec);
    _main_loading_editing_editing_2.trigger = new Event("key_press", "ui");
    _main_loading_editing_editing_2.setGuard(this._main_loading_editing_editing_2_guard);
    this.states["/main/loading/editing/editing"].addTransition(_main_loading_editing_editing_2);
    var _main_loading_editing_editing_3 = new Transition(this, this.states["/main/loading/editing/editing"], [this.states["/main/loading/editing/editing"]]);
    _main_loading_editing_editing_3.setAction(this._main_loading_editing_editing_3_exec);
    _main_loading_editing_editing_3.trigger = new Event("key_press", "ui");
    _main_loading_editing_editing_3.setGuard(this._main_loading_editing_editing_3_guard);
    this.states["/main/loading/editing/editing"].addTransition(_main_loading_editing_editing_3);
    var _main_loading_editing_editing_4 = new Transition(this, this.states["/main/loading/editing/editing"], [this.states["/main/waiting_click"]]);
    _main_loading_editing_editing_4.setAction(this._main_loading_editing_editing_4_exec);
    _main_loading_editing_editing_4.trigger = new Event("key_press", "ui");
    _main_loading_editing_editing_4.setGuard(this._main_loading_editing_editing_4_guard);
    this.states["/main/loading/editing/editing"].addTransition(_main_loading_editing_editing_4);
    
    // transition /main/loading/show_files_to_load/not_showing
    var _main_loading_show_files_to_load_not_showing_0 = new Transition(this, this.states["/main/loading/show_files_to_load/not_showing"], [this.states["/main/loading/show_files_to_load/showing"]]);
    _main_loading_show_files_to_load_not_showing_0.setAction(this._main_loading_show_files_to_load_not_showing_0_exec);
    _main_loading_show_files_to_load_not_showing_0.trigger = new Event("filesToLoad", null);
    this.states["/main/loading/show_files_to_load/not_showing"].addTransition(_main_loading_show_files_to_load_not_showing_0);
    
    // transition /main/loading/show_files_to_load/showing
    var _main_loading_show_files_to_load_showing_0 = new Transition(this, this.states["/main/loading/show_files_to_load/showing"], [this.states["/main/loading/show_files_to_load/not_showing"]]);
    _main_loading_show_files_to_load_showing_0.setAction(this._main_loading_show_files_to_load_showing_0_exec);
    _main_loading_show_files_to_load_showing_0.trigger = new Event("mouse_down", "ui");
    this.states["/main/loading/show_files_to_load/showing"].addTransition(_main_loading_show_files_to_load_showing_0);
    
    // transition /editing_elsewhere
    var _editing_elsewhere_0 = new Transition(this, this.states["/editing_elsewhere"], [this.states["/main/waiting_click"]]);
    _editing_elsewhere_0.trigger = new Event("end_editing", null);
    this.states["/editing_elsewhere"].addTransition(_editing_elsewhere_0);
    
    // transition /ctrl_pressing
    var _ctrl_pressing_0 = new Transition(this, this.states["/ctrl_pressing"], [this.states["/main/waiting_click"]]);
    _ctrl_pressing_0.trigger = new Event("key_up", "ui");
    _ctrl_pressing_0.setGuard(this._ctrl_pressing_0_guard);
    this.states["/ctrl_pressing"].addTransition(_ctrl_pressing_0);
    var _ctrl_pressing_1 = new Transition(this, this.states["/ctrl_pressing"], [this.states["/ctrl_alt_pressing"]]);
    _ctrl_pressing_1.trigger = new Event("key_down", "ui");
    _ctrl_pressing_1.setGuard(this._ctrl_pressing_1_guard);
    this.states["/ctrl_pressing"].addTransition(_ctrl_pressing_1);
    
    // transition /ctrl_alt_pressing
    var _ctrl_alt_pressing_0 = new Transition(this, this.states["/ctrl_alt_pressing"], [this.states["/main/waiting_click"]]);
    _ctrl_alt_pressing_0.setAction(this._ctrl_alt_pressing_0_exec);
    _ctrl_alt_pressing_0.trigger = new Event("key_down", "ui");
    _ctrl_alt_pressing_0.setGuard(this._ctrl_alt_pressing_0_guard);
    this.states["/ctrl_alt_pressing"].addTransition(_ctrl_alt_pressing_0);
    var _ctrl_alt_pressing_1 = new Transition(this, this.states["/ctrl_alt_pressing"], [this.states["/ctrl_pressing"]]);
    _ctrl_alt_pressing_1.trigger = new Event("key_up", "ui");
    _ctrl_alt_pressing_1.setGuard(this._ctrl_alt_pressing_1_guard);
    this.states["/ctrl_alt_pressing"].addTransition(_ctrl_alt_pressing_1);
    var _ctrl_alt_pressing_2 = new Transition(this, this.states["/ctrl_alt_pressing"], [this.states["/main/waiting_click"]]);
    _ctrl_alt_pressing_2.trigger = new Event("key_up", "ui");
    _ctrl_alt_pressing_2.setGuard(this._ctrl_alt_pressing_2_guard);
    this.states["/ctrl_alt_pressing"].addTransition(_ctrl_alt_pressing_2);
    
    // transition /main
    var _main_0 = new Transition(this, this.states["/main"], [this.states["/editing_elsewhere"]]);
    _main_0.trigger = new Event("editing", null);
    this.states["/main"].addTransition(_main_0);
    var _main_1 = new Transition(this, this.states["/main"], [this.states["/main"]]);
    _main_1.setAction(this._main_1_exec);
    _main_1.trigger = new Event("mouse_down", "ui");
    _main_1.setGuard(this._main_1_guard);
    this.states["/main"].addTransition(_main_1);
};

TopBar.prototype._draw_widget_enter = function() {
    this.addTimer(0, 0.1);
};

TopBar.prototype._draw_widget_exit = function() {
    this.removeTimer(0);
};

TopBar.prototype._main_displaying_error_load_enter = function() {
    this.addTimer(1, 5);
};

TopBar.prototype._main_displaying_error_load_exit = function() {
    this.removeTimer(1);
};

TopBar.prototype._main_displaying_disconnected_enter = function() {
    this.addTimer(2, 5);
};

TopBar.prototype._main_displaying_disconnected_exit = function() {
    this.removeTimer(2);
};

TopBar.prototype._main_1_exec = function(parameters) {
    var x = parameters[0];
    var y = parameters[1];
    console.log("I got it");
    this.big_step.outputEventOM(new Event("narrow_cast", null, [this, 'parent/messenger', new Event("disconnect", null, new Array())]));
};

TopBar.prototype._main_1_guard = function(parameters) {
    var x = parameters[0];
    var y = parameters[1];
    return gui.isIn(this.topBarX, 0, x, y, this.screenWidth-8*10, 0, 8*10,      this.disconnectHeight);
};

TopBar.prototype._draw_widget_0_exec = function(parameters) {
    this.textsTopBar = gui.drawTopBar(this.mainField, this.topBarX, this.topBarY, this.topBarHeight, this.firstSquareWidth,
    this.screenWidth-this.firstSquareWidth, "FILE", "User Name", "File Name", "Connection Name", this.disconnectHeight);
    this.subMenuWidget = gui.drawMenuBar(this.mainField, this.topBarX,
     this.topBarY+this.topBarHeight, this.firstSquareWidth, this.menuHeight, this.textsMenu);
    this.subMenuWidget.hide();
    this.errorLoadWidget =  gui.drawMessageWidget(this.mainField, this.screenWidth, this.menuHeight,
    "ERROR MESSAGE: the file you want to load doesn't not exist");
    this.errorLoadWidget.hide();
    this.disconnectedWidget =  gui.drawMessageWidget(this.mainField, this.screenWidth, this.menuHeight,
    "You have been disconnected");
    this.disconnectedWidget.hide();
};

TopBar.prototype._main_waiting_click_0_guard = function(parameters) {
    var keyCode = parameters[0];
    return parseInt(keyCode) == 17;
};

TopBar.prototype._main_waiting_click_1_exec = function(parameters) {
    var idSocket = parameters[0];
    var clientName = parameters[1];
    this.textsTopBar['firstWord'].attr('text', clientName);
    this.textsTopBar['lastWord'].attr('text', idSocket);
};

TopBar.prototype._main_waiting_click_2_exec = function(parameters) {
    var x = parameters[0];
    var y = parameters[1];
    this.menuDisplayed=true;
    this.subMenuWidget = gui.drawMenuBar(this.mainField, this.topBarX,
     this.topBarY+this.topBarHeight, this.firstSquareWidth, this.menuHeight, this.textsMenu);
    this.subMenuWidget.show();
};

TopBar.prototype._main_waiting_click_2_guard = function(parameters) {
    var x = parameters[0];
    var y = parameters[1];
    return gui.isIn(this.topBarX, this.topBarY, x, y, 0, 0, this.firstSquareWidth,       this.topBarHeight) && !this.menuDisplayed;
};

TopBar.prototype._main_waiting_click_3_exec = function(parameters) {
    this.errorLoadWidget.show();
};

TopBar.prototype._main_waiting_click_4_exec = function(parameters) {
    this.disconnectedWidget.show();
};

TopBar.prototype._main_displaying_error_load_0_exec = function(parameters) {
    this.errorLoadWidget.hide();
};

TopBar.prototype._main_displaying_disconnected_0_exec = function(parameters) {
    this.disconnectedWidget.hide();
};

TopBar.prototype._main_menu_displayed_0_exec = function(parameters) {
    var x = parameters[0];
    var y = parameters[1];
    this.menuDisplayed=false;
    var retour = gui.createEditTextInput(this.topBarX, this.topBarY, this.topBarHeight, this.mainField,
    (this.screenWidth-this.firstSquareWidth)/2 + this.firstSquareWidth, this.topBarY, this.textsTopBar['middleWord']);
    this.cursorPos = retour[0];
    this.svgText = retour[1];
    this.subMenuWidget.hide();
    this.big_step.outputEventOM(new Event("narrow_cast", null, [this, 'parent/spreadSheet/selectedCell', new Event("editing", null, new Array())]));
};

TopBar.prototype._main_menu_displayed_0_guard = function(parameters) {
    var x = parameters[0];
    var y = parameters[1];
    return gui.isIn(this.topBarX, this.topBarY, x, y, 0, this.topBarHeight, this.firstSquareWidth,         this.menuHeight) && this.menuDisplayed;
};

TopBar.prototype._main_menu_displayed_1_exec = function(parameters) {
    var x = parameters[0];
    var y = parameters[1];
    this.menuDisplayed=false;
    var retour = gui.createEditTextInput(this.topBarX, this.topBarY, this.topBarHeight, this.mainField,
    (this.screenWidth-this.firstSquareWidth)/2 + this.firstSquareWidth, this.topBarY, this.textsTopBar['middleWord']);
    this.cursorPos = retour[0];
    this.svgText = retour[1];
    this.subMenuWidget.hide();
    this.big_step.outputEventOM(new Event("narrow_cast", null, [this, 'parent/spreadSheet/selectedCell', new Event("editing", null, new Array())]));
    this.big_step.outputEventOM(new Event("narrow_cast", null, [this, 'parent/messenger', new Event("askFilesToLoad", null, new Array())]));
};

TopBar.prototype._main_menu_displayed_1_guard = function(parameters) {
    var x = parameters[0];
    var y = parameters[1];
    return gui.isIn(this.topBarX, this.topBarY, x, y, 0, this.topBarHeight+this.menuHeight, this.firstSquareWidth,         this.menuHeight) && this.menuDisplayed;
};

TopBar.prototype._main_menu_displayed_2_exec = function(parameters) {
    var x = parameters[0];
    var y = parameters[1];
    this.menuDisplayed=false;
    this.subMenuWidget.hide();
};

TopBar.prototype._main_menu_displayed_2_guard = function(parameters) {
    var x = parameters[0];
    var y = parameters[1];
    return (!gui.isIn(this.topBarX, this.topBarY, x, y, 0, this.topBarHeight*2, this.firstSquareWidth,         this.menuHeight) && !gui.isIn(this.topBarX, this.topBarY, x, y, 0, this.topBarHeight, this.firstSquareWidth,          this.menuHeight))&& this.menuDisplayed;
};

TopBar.prototype._main_saving_0_exec = function(parameters) {
    var keyCode = parameters[0];
    var text = String.fromCharCode(keyCode);
    this.cursorPos = gui.editTextInput(text, this.svgText, this.cursorPos);
};

TopBar.prototype._main_saving_0_guard = function(parameters) {
    var keyCode = parameters[0];
    return (jQuery.inArray(parseInt(keyCode), [13, 8, 37, 38, 39, 40]) == -1);
};

TopBar.prototype._main_saving_1_exec = function(parameters) {
    var keyCode = parameters[0];
    this.cursorPos = gui.deleteLastElementBeforeCursor(this.svgText, this.cursorPos);
};

TopBar.prototype._main_saving_1_guard = function(parameters) {
    var keyCode = parameters[0];
    return parseInt(keyCode)==8 && this.cursorPos >0;
};

TopBar.prototype._main_saving_2_exec = function(parameters) {
    var keyCode = parameters[0];
    this.cursorPos = 	gui.mooveCursor(this.svgText, this.cursorPos,-1);
};

TopBar.prototype._main_saving_2_guard = function(parameters) {
    var keyCode = parameters[0];
    return parseInt(keyCode)==37;
};

TopBar.prototype._main_saving_3_exec = function(parameters) {
    var keyCode = parameters[0];
    this.cursorPos = 	gui.mooveCursor(this.svgText, this.cursorPos,1);
};

TopBar.prototype._main_saving_3_guard = function(parameters) {
    var keyCode = parameters[0];
    return parseInt(keyCode)==39;
};

TopBar.prototype._main_saving_4_exec = function(parameters) {
    var keyCode = parameters[0];
    text = gui.getText(this.svgText);
    this.big_step.outputEventOM(new Event("narrow_cast", null, [this, 'parent/messenger', new Event("save", null, [text])]));
    this.big_step.outputEventOM(new Event("narrow_cast", null, [this, 'parent/spreadSheet/selectedCell', new Event("end_editing", null, new Array())]));
    gui.cleanText(this.svgText);
    this.textsTopBar['middleWord'].attr("text", text);
};

TopBar.prototype._main_saving_4_guard = function(parameters) {
    var keyCode = parameters[0];
    return parseInt(keyCode)==13;
};

TopBar.prototype._main_loading_editing_editing_0_exec = function(parameters) {
    var keyCode = parameters[0];
    var text = String.fromCharCode(keyCode);
    this.cursorPos = gui.editTextInput(text, this.svgText, this.cursorPos);
};

TopBar.prototype._main_loading_editing_editing_0_guard = function(parameters) {
    var keyCode = parameters[0];
    return (jQuery.inArray(parseInt(keyCode), [13, 8, 37, 38, 39, 40]) == -1);
};

TopBar.prototype._main_loading_editing_editing_1_exec = function(parameters) {
    var keyCode = parameters[0];
    this.cursorPos = gui.deleteLastElementBeforeCursor(this.svgText, this.cursorPos);
};

TopBar.prototype._main_loading_editing_editing_1_guard = function(parameters) {
    var keyCode = parameters[0];
    return parseInt(keyCode)==8 && this.cursorPos >0;
};

TopBar.prototype._main_loading_editing_editing_2_exec = function(parameters) {
    var keyCode = parameters[0];
    this.cursorPos = 	gui.mooveCursor(this.svgText, this.cursorPos,-1);
};

TopBar.prototype._main_loading_editing_editing_2_guard = function(parameters) {
    var keyCode = parameters[0];
    return parseInt(keyCode)==37;
};

TopBar.prototype._main_loading_editing_editing_3_exec = function(parameters) {
    var keyCode = parameters[0];
    this.cursorPos = 	gui.mooveCursor(this.svgText, this.cursorPos,1);
};

TopBar.prototype._main_loading_editing_editing_3_guard = function(parameters) {
    var keyCode = parameters[0];
    return parseInt(keyCode)==39;
};

TopBar.prototype._main_loading_editing_editing_4_exec = function(parameters) {
    var keyCode = parameters[0];
    text = gui.getText(this.svgText);
    this.filesToLoadWindow.hide();
    this.big_step.outputEventOM(new Event("narrow_cast", null, [this, 'parent/messenger', new Event("load", null, [text])]));
    this.big_step.outputEventOM(new Event("narrow_cast", null, [this, 'parent/spreadSheet/selectedCell', new Event("end_editing", null, new Array())]));
    gui.cleanText(this.svgText);
    this.svgText.attr("text", text);
};

TopBar.prototype._main_loading_editing_editing_4_guard = function(parameters) {
    var keyCode = parameters[0];
    return parseInt(keyCode)==13;
};

TopBar.prototype._main_loading_show_files_to_load_not_showing_0_exec = function(parameters) {
    var fileNames = parameters[0];
    this.filesToLoadWindow = gui.drawFilesToLoadWidget(this.mainField, this.screenWidth, this.menuHeight, fileNames);
    this.big_step.outputEventOM(new Event("narrow_cast", null, [this, 'parent/messenger', new Event("filesToLoadDisplayed", null, new Array())]));
};

TopBar.prototype._main_loading_show_files_to_load_showing_0_exec = function(parameters) {
    this.filesToLoadWindow.hide();
};

TopBar.prototype._ctrl_pressing_0_guard = function(parameters) {
    var keyCode = parameters[0];
    return parseInt(keyCode) == 17;
};

TopBar.prototype._ctrl_pressing_1_guard = function(parameters) {
    var keyCode = parameters[0];
    return parseInt(keyCode) == 18;
};

TopBar.prototype._ctrl_alt_pressing_0_exec = function(parameters) {
    var keyCode = parameters[0];
    text = gui.getText(this.textsTopBar['middleWord']);
    this.big_step.outputEventOM(new Event("narrow_cast", null, [this, 'parent/messenger', new Event("save", null, [text])]));
    this.big_step.outputEventOM(new Event("narrow_cast", null, [this, 'parent/spreadSheet/selectedCell', new Event("end_editing", null, new Array())]));
    gui.cleanText(this.svgText);
    this.textsTopBar['middleWord'].attr("text", text);
};

TopBar.prototype._ctrl_alt_pressing_0_guard = function(parameters) {
    var keyCode = parameters[0];
    return parseInt(keyCode) == 83;
};

TopBar.prototype._ctrl_alt_pressing_1_guard = function(parameters) {
    var keyCode = parameters[0];
    return parseInt(keyCode) == 18;
};

TopBar.prototype._ctrl_alt_pressing_2_guard = function(parameters) {
    var keyCode = parameters[0];
    return parseInt(keyCode) == 17;
};

TopBar.prototype.initializeStatechart = function() {
    // enter default state
    var states = this.states["/draw_widget"].getEffectiveTargetStates();
    this.updateConfiguration(states);
    for (var state_idx in states) {
        if (!states.hasOwnProperty(state_idx)) continue;
        var state = states[state_idx]
        if (state.enter) {
            state.enter();
        }
    }
};

// add symbol 'TopBar' to package 'DSheet_GUI'
DSheet_GUI.TopBar = TopBar;

var SpreadSheet = function(controller, cellWidth, cellHeight, columnsNumber, rowNumber, sheetOriginX, sheetOriginY, spreadSheetWidth, spreadSheetHeight, mainField) {
    RuntimeClassBase.call(this, controller);
    
    this.semantics.big_step_maximality = StatechartSemantics.TakeMany;
    this.semantics.internal_event_lifeline = StatechartSemantics.Queue;
    this.semantics.input_event_lifeline = StatechartSemantics.FirstComboStep;
    this.semantics.priority = StatechartSemantics.SourceParent;
    this.semantics.concurrency = StatechartSemantics.Single;
    
    // build Statechart structure
    this.build_statechart_structure();
    
    // user defined attributes
    this.spreadSheetW = null;
    this.cellWidth = null;
    this.cellHeight = null;
    this.columnsNumber = null;
    this.rowNumber = null;
    this.sheetOriginX = null;
    this.sheetOriginY = null;
    this.spreadSheetWidth = null;
    this.spreadSheetHeight = null;
    this.mainField = null;
    
    // call user defined constructor
    SpreadSheet.prototype.user_defined_constructor.call(this, cellWidth, cellHeight, columnsNumber, rowNumber, sheetOriginX, sheetOriginY, spreadSheetWidth, spreadSheetHeight, mainField);
};
SpreadSheet.prototype = new Object();
(function() {
    var proto = new RuntimeClassBase();
    for (prop in proto) {
        SpreadSheet.prototype[prop] = proto[prop];
    }
})();

SpreadSheet.prototype.user_defined_constructor = function(cellWidth, cellHeight, columnsNumber, rowNumber, sheetOriginX, sheetOriginY, spreadSheetWidth, spreadSheetHeight, mainField) {
    this.mainField = mainField;
    
    this.cellWidth = cellWidth ;
    this.cellHeight = cellHeight;
    this.columnsNumber = columnsNumber;
    this.rowNumber = rowNumber;
    
    this.sheetOriginX = sheetOriginX;
    this.sheetOriginY = sheetOriginY;
    
    this.spreadSheetWidth = spreadSheetWidth;
    this.spreadSheetHeight = spreadSheetHeight;
    
    this.counter = -1;
    
    this.allSVGText = {};
    
    this.spreadSheetW = gui.createSheet(sheetOriginX, sheetOriginY,
    spreadSheetWidth,spreadSheetHeight, columnsNumber, rowNumber, cellWidth,
    cellHeight, mainField);
    gui.bind_event(window, gui.EVENTS.KEY_PRESS, this.controller,
    'key_press');
    gui.bind_event(window, gui.EVENTS.KEY_DOWN, this.controller,
    'key_down');
    gui.bind_event(window, gui.EVENTS.KEY_UP, this.controller,
    'key_up');
    gui.bind_event(window, gui.EVENTS.MOUSE_MOVE, this.controller,
    'mouse_move');
    gui.bind_event(window, gui.EVENTS.MOUSE_DOWN, this.controller,
    'mouse_down');
    gui.bind_event(window, gui.EVENTS.MOUSE_UP, this.controller,
    'mouse_up');
    gui.bind_event(window, gui.EVENTS.DBL_CLICK, this.controller,
    'dbl_click');
};

SpreadSheet.prototype.user_defined_destructor = function() {
};


// builds Statechart structure
SpreadSheet.prototype.build_statechart_structure = function() {
    
    // state <root>
    this.states[""] = new State(0, this);
    
    // state /initializing
    this.states["/initializing"] = new State(1, this);
    this.states["/initializing"].setEnter(this._initializing_enter);
    this.states["/initializing"].setExit(this._initializing_exit);
    
    // state /creating_selectedCell
    this.states["/creating_selectedCell"] = new State(2, this);
    
    // state /creating_areaSelectedCells
    this.states["/creating_areaSelectedCells"] = new State(3, this);
    
    // state /running
    this.states["/running"] = new ParallelState(4, this);
    
    // state /running/handle_ui_event
    this.states["/running/handle_ui_event"] = new State(5, this);
    
    // state /running/handle_ui_event/main
    this.states["/running/handle_ui_event/main"] = new State(6, this);
    
    // state /running/running_update
    this.states["/running/running_update"] = new State(7, this);
    
    // state /running/running_update/main
    this.states["/running/running_update/main"] = new State(8, this);
    
    // add children
    this.states[""].addChild(this.states["/initializing"]);
    this.states[""].addChild(this.states["/creating_selectedCell"]);
    this.states[""].addChild(this.states["/creating_areaSelectedCells"]);
    this.states[""].addChild(this.states["/running"]);
    this.states["/running"].addChild(this.states["/running/handle_ui_event"]);
    this.states["/running"].addChild(this.states["/running/running_update"]);
    this.states["/running/handle_ui_event"].addChild(this.states["/running/handle_ui_event/main"]);
    this.states["/running/running_update"].addChild(this.states["/running/running_update/main"]);
    this.states[""].fixTree();
    this.states[""].default_state = this.states["/initializing"];
    this.states["/running/handle_ui_event"].default_state = this.states["/running/handle_ui_event/main"];
    this.states["/running/running_update"].default_state = this.states["/running/running_update/main"];
    
    // transition /initializing
    var _initializing_0 = new Transition(this, this.states["/initializing"], [this.states["/creating_selectedCell"]]);
    _initializing_0.setAction(this._initializing_0_exec);
    _initializing_0.trigger = new Event("_0after");
    this.states["/initializing"].addTransition(_initializing_0);
    
    // transition /creating_selectedCell
    var _creating_selectedCell_0 = new Transition(this, this.states["/creating_selectedCell"], [this.states["/creating_areaSelectedCells"]]);
    _creating_selectedCell_0.setAction(this._creating_selectedCell_0_exec);
    _creating_selectedCell_0.trigger = new Event("instance_created", null);
    this.states["/creating_selectedCell"].addTransition(_creating_selectedCell_0);
    
    // transition /creating_areaSelectedCells
    var _creating_areaSelectedCells_0 = new Transition(this, this.states["/creating_areaSelectedCells"], [this.states["/running"]]);
    _creating_areaSelectedCells_0.setAction(this._creating_areaSelectedCells_0_exec);
    _creating_areaSelectedCells_0.trigger = new Event("instance_created", null);
    this.states["/creating_areaSelectedCells"].addTransition(_creating_areaSelectedCells_0);
    
    // transition /running/handle_ui_event/main
    var _running_handle_ui_event_main_0 = new Transition(this, this.states["/running/handle_ui_event/main"], [this.states["/running/handle_ui_event/main"]]);
    _running_handle_ui_event_main_0.setAction(this._running_handle_ui_event_main_0_exec);
    _running_handle_ui_event_main_0.trigger = new Event("mouse_down", "ui");
    this.states["/running/handle_ui_event/main"].addTransition(_running_handle_ui_event_main_0);
    
    // transition /running/running_update/main
    var _running_running_update_main_0 = new Transition(this, this.states["/running/running_update/main"], [this.states["/running/running_update/main"]]);
    _running_running_update_main_0.setAction(this._running_running_update_main_0_exec);
    _running_running_update_main_0.trigger = new Event("updateTextCell", null);
    this.states["/running/running_update/main"].addTransition(_running_running_update_main_0);
    var _running_running_update_main_1 = new Transition(this, this.states["/running/running_update/main"], [this.states["/running/running_update/main"]]);
    _running_running_update_main_1.setAction(this._running_running_update_main_1_exec);
    _running_running_update_main_1.trigger = new Event("bad_input", null);
    this.states["/running/running_update/main"].addTransition(_running_running_update_main_1);
};

SpreadSheet.prototype._initializing_enter = function() {
    this.addTimer(0, 0.1);
};

SpreadSheet.prototype._initializing_exit = function() {
    this.removeTimer(0);
};

SpreadSheet.prototype._initializing_0_exec = function(parameters) {
    this.big_step.outputEventOM(new Event("create_instance", null, [this, "selectedCell", "SelectedCell", this.cellWidth, this.cellHeight, this.columnsNumber, this.rowNumber, this.sheetOriginX, this.sheetOriginY, this.mainField, this.allSVGText]));
};

SpreadSheet.prototype._creating_selectedCell_0_exec = function(parameters) {
    var association_name = parameters[0];
    this.big_step.outputEventOM(new Event("start_instance", null, [this, association_name]));
    this.big_step.outputEventOM(new Event("create_instance", null, [this, "areaSelectedCells", "AreaSelectedCells", this.spreadSheetWidth, this.spreadSheetHeight, this.sheetOriginX, this.sheetOriginY, this.cellWidth, this.cellHeight, this.mainField]));
};

SpreadSheet.prototype._creating_areaSelectedCells_0_exec = function(parameters) {
    var association_name = parameters[0];
    this.big_step.outputEventOM(new Event("start_instance", null, [this, association_name]));
};

SpreadSheet.prototype._running_handle_ui_event_main_0_exec = function(parameters) {
    var x = parameters[0];
    var y = parameters[1];
    //which case ?
    
    x = gui.getRowBoundary(x, this.sheetOriginX,
    this.spreadSheetWidth, this.cellWidth);
    y = gui.getColBoundary(y, this.sheetOriginY,
    this.spreadSheetHeight, this.cellHeight);
    this.big_step.outputEventOM(new Event("narrow_cast", null, [this, 'selectedCell', new Event("move", null, [x, y])]));
};

SpreadSheet.prototype._running_running_update_main_0_exec = function(parameters) {
    var xCase = parameters[0];
    var yCase = parameters[1];
    var text = parameters[2];
    if(xCase < this.columnsNumber && yCase < this.rowNumber){
    gui.updateCell(this.mainField,text,this.sheetOriginX+this.cellWidth, this.sheetOriginY+this.cellHeight, this.cellHeight,
    xCase*this.cellWidth,
    yCase*this.cellHeight, this.allSVGText);
    }
};

SpreadSheet.prototype._running_running_update_main_1_exec = function(parameters) {
    var xCase = parameters[0];
    var yCase = parameters[1];
    var newText = parameters[2];
    newText = gui.putErrorRed(newText);
    gui.updateCell(this.mainField,newText,this.sheetOriginX, this.sheetOriginY, this.cellHeight,
    xCase*this.cellWidth,
    yCase*this.cellHeight, this.allSVGText);
};

SpreadSheet.prototype.initializeStatechart = function() {
    // enter default state
    var states = this.states["/initializing"].getEffectiveTargetStates();
    this.updateConfiguration(states);
    for (var state_idx in states) {
        if (!states.hasOwnProperty(state_idx)) continue;
        var state = states[state_idx]
        if (state.enter) {
            state.enter();
        }
    }
};

// add symbol 'SpreadSheet' to package 'DSheet_GUI'
DSheet_GUI.SpreadSheet = SpreadSheet;

var AreaSelectedCells = function(controller, spreadSheetWidth, spreadSheetHeight, sheetOriginX, sheetOriginY, cellWidth, cellHeight, mainField) {
    RuntimeClassBase.call(this, controller);
    
    this.semantics.big_step_maximality = StatechartSemantics.TakeMany;
    this.semantics.internal_event_lifeline = StatechartSemantics.Queue;
    this.semantics.input_event_lifeline = StatechartSemantics.FirstComboStep;
    this.semantics.priority = StatechartSemantics.SourceParent;
    this.semantics.concurrency = StatechartSemantics.Single;
    
    // build Statechart structure
    this.build_statechart_structure();
    
    // call user defined constructor
    AreaSelectedCells.prototype.user_defined_constructor.call(this, spreadSheetWidth, spreadSheetHeight, sheetOriginX, sheetOriginY, cellWidth, cellHeight, mainField);
};
AreaSelectedCells.prototype = new Object();
(function() {
    var proto = new RuntimeClassBase();
    for (prop in proto) {
        AreaSelectedCells.prototype[prop] = proto[prop];
    }
})();

AreaSelectedCells.prototype.user_defined_constructor = function(spreadSheetWidth, spreadSheetHeight, sheetOriginX, sheetOriginY, cellWidth, cellHeight, mainField) {
    this.cellWidth = cellWidth;
    this.cellHeight = cellHeight;
    this.mainField = mainField;
    this.sheetOriginX = sheetOriginX;
    this.sheetOriginY = sheetOriginY;
    this.spreadSheetHeight = spreadSheetHeight;
    this.spreadSheetWidth = spreadSheetWidth;
    
    this.columnsNumber = (this.spreadSheetWidth/cellWidth)-1;
    this.rowNumber = (this.spreadSheetHeight/cellHeight)-1;
    
    this.xA = -1;
    this.yA = -1;
    this.xB = -1;
    this.yB = -1;
    this.rectangle = {};
};

AreaSelectedCells.prototype.user_defined_destructor = function() {
};


// builds Statechart structure
AreaSelectedCells.prototype.build_statechart_structure = function() {
    
    // state <root>
    this.states[""] = new State(0, this);
    
    // state /not_selecting
    this.states["/not_selecting"] = new State(1, this);
    
    // state /removing_old_selection
    this.states["/removing_old_selection"] = new State(2, this);
    
    // state /ctrl_pressing
    this.states["/ctrl_pressing"] = new State(3, this);
    
    // state /in_selecting
    this.states["/in_selecting"] = new State(4, this);
    
    // add children
    this.states[""].addChild(this.states["/not_selecting"]);
    this.states[""].addChild(this.states["/removing_old_selection"]);
    this.states[""].addChild(this.states["/ctrl_pressing"]);
    this.states[""].addChild(this.states["/in_selecting"]);
    this.states[""].fixTree();
    this.states[""].default_state = this.states["/not_selecting"];
    
    // transition /not_selecting
    var _not_selecting_0 = new Transition(this, this.states["/not_selecting"], [this.states["/removing_old_selection"]]);
    _not_selecting_0.setAction(this._not_selecting_0_exec);
    _not_selecting_0.trigger = new Event("mouse_down", "ui");
    this.states["/not_selecting"].addTransition(_not_selecting_0);
    var _not_selecting_1 = new Transition(this, this.states["/not_selecting"], [this.states["/ctrl_pressing"]]);
    _not_selecting_1.setAction(this._not_selecting_1_exec);
    _not_selecting_1.trigger = new Event("key_down", "ui");
    _not_selecting_1.setGuard(this._not_selecting_1_guard);
    this.states["/not_selecting"].addTransition(_not_selecting_1);
    
    // transition /removing_old_selection
    var _removing_old_selection_0 = new Transition(this, this.states["/removing_old_selection"], [this.states["/in_selecting"]]);
    _removing_old_selection_0.setAction(this._removing_old_selection_0_exec);
    _removing_old_selection_0.setGuard(this._removing_old_selection_0_guard);
    this.states["/removing_old_selection"].addTransition(_removing_old_selection_0);
    var _removing_old_selection_1 = new Transition(this, this.states["/removing_old_selection"], [this.states["/not_selecting"]]);
    _removing_old_selection_1.setGuard(this._removing_old_selection_1_guard);
    this.states["/removing_old_selection"].addTransition(_removing_old_selection_1);
    
    // transition /ctrl_pressing
    var _ctrl_pressing_0 = new Transition(this, this.states["/ctrl_pressing"], [this.states["/ctrl_pressing"]]);
    _ctrl_pressing_0.setAction(this._ctrl_pressing_0_exec);
    _ctrl_pressing_0.trigger = new Event("key_down", "ui");
    _ctrl_pressing_0.setGuard(this._ctrl_pressing_0_guard);
    this.states["/ctrl_pressing"].addTransition(_ctrl_pressing_0);
    var _ctrl_pressing_1 = new Transition(this, this.states["/ctrl_pressing"], [this.states["/ctrl_pressing"]]);
    _ctrl_pressing_1.setAction(this._ctrl_pressing_1_exec);
    _ctrl_pressing_1.trigger = new Event("key_down", "ui");
    _ctrl_pressing_1.setGuard(this._ctrl_pressing_1_guard);
    this.states["/ctrl_pressing"].addTransition(_ctrl_pressing_1);
    var _ctrl_pressing_2 = new Transition(this, this.states["/ctrl_pressing"], [this.states["/ctrl_pressing"]]);
    _ctrl_pressing_2.setAction(this._ctrl_pressing_2_exec);
    _ctrl_pressing_2.trigger = new Event("key_down", "ui");
    _ctrl_pressing_2.setGuard(this._ctrl_pressing_2_guard);
    this.states["/ctrl_pressing"].addTransition(_ctrl_pressing_2);
    var _ctrl_pressing_3 = new Transition(this, this.states["/ctrl_pressing"], [this.states["/not_selecting"]]);
    _ctrl_pressing_3.setAction(this._ctrl_pressing_3_exec);
    _ctrl_pressing_3.trigger = new Event("key_up", "ui");
    _ctrl_pressing_3.setGuard(this._ctrl_pressing_3_guard);
    this.states["/ctrl_pressing"].addTransition(_ctrl_pressing_3);
    
    // transition /in_selecting
    var _in_selecting_0 = new Transition(this, this.states["/in_selecting"], [this.states["/in_selecting"]]);
    _in_selecting_0.setAction(this._in_selecting_0_exec);
    _in_selecting_0.trigger = new Event("mouse_move", "ui");
    this.states["/in_selecting"].addTransition(_in_selecting_0);
    var _in_selecting_1 = new Transition(this, this.states["/in_selecting"], [this.states["/not_selecting"]]);
    _in_selecting_1.setAction(this._in_selecting_1_exec);
    _in_selecting_1.trigger = new Event("mouse_up", "ui");
    this.states["/in_selecting"].addTransition(_in_selecting_1);
};

AreaSelectedCells.prototype._not_selecting_0_exec = function(parameters) {
    var x = parameters[0];
    var y = parameters[1];
    this.xA = gui.getRowBoundary(x, this.sheetOriginX,
    this.spreadSheetWidth, this.cellWidth);
    this.yA = gui.getColBoundary(y, this.sheetOriginY,
    this.spreadSheetHeight, this.cellHeight);
};

AreaSelectedCells.prototype._not_selecting_1_exec = function(parameters) {
    var keyCode = parameters[0];
};

AreaSelectedCells.prototype._not_selecting_1_guard = function(parameters) {
    var keyCode = parameters[0];
    return parseInt(keyCode) == 17;
};

AreaSelectedCells.prototype._removing_old_selection_0_exec = function(parameters) {
    gui.removeElement(this.rectangle);
};

AreaSelectedCells.prototype._removing_old_selection_0_guard = function(parameters) {
    return this.xA >= 0 && this.yA >= 0  && this.columnsNumber > this.xA       && this.rowNumber > this.yA;
};

AreaSelectedCells.prototype._removing_old_selection_1_guard = function(parameters) {
    return !(this.xA >= 0 && this.yA >= 0  && this.columnsNumber > this.xA       && this.rowNumber > this.yA);
};

AreaSelectedCells.prototype._ctrl_pressing_0_exec = function(parameters) {
    var keyCode = parameters[0];
    var option ="";
    var xA, yA, xB, yB, diffX, diffY;
    if(parseInt(keyCode) == 67){
    option = "copy";
    xA = this.xA;
    yA = this.yA;
    xB = this.xB;
    yB = this.yB;
    }
    else if(parseInt(keyCode) == 86){
    option = "past";
    xA = this.xA;
    yA = this.yA;
    xB = this.xA;
    yB = this.yA;
    }
    else if(parseInt(keyCode) == 88){
    option = "cut";
    xA = this.xA;
    yA = this.yA;
    xB = this.xB;
    yB = this.yB;
    }
    this.big_step.outputEventOM(new Event("narrow_cast", null, [this, 'parent/parent/messenger', new Event("copy_cut_past", null, [option, xA, yA, xB, yB])]));
};

AreaSelectedCells.prototype._ctrl_pressing_0_guard = function(parameters) {
    var keyCode = parameters[0];
    return (jQuery.inArray(parseInt(keyCode), [67, 86, 88]) != -1);
};

AreaSelectedCells.prototype._ctrl_pressing_1_exec = function(parameters) {
    var keyCode = parameters[0];
    // z has been pressed
    this.big_step.outputEventOM(new Event("narrow_cast", null, [this, 'parent/parent/messenger', new Event("undo", null, new Array())]));
};

AreaSelectedCells.prototype._ctrl_pressing_1_guard = function(parameters) {
    var keyCode = parameters[0];
    return (parseInt(keyCode) == 90);
};

AreaSelectedCells.prototype._ctrl_pressing_2_exec = function(parameters) {
    var keyCode = parameters[0];
    // y has been pressed
    this.big_step.outputEventOM(new Event("narrow_cast", null, [this, 'parent/parent/messenger', new Event("redo", null, new Array())]));
};

AreaSelectedCells.prototype._ctrl_pressing_2_guard = function(parameters) {
    var keyCode = parameters[0];
    return (parseInt(keyCode) == 89);
};

AreaSelectedCells.prototype._ctrl_pressing_3_exec = function(parameters) {
    var keyCode = parameters[0];
};

AreaSelectedCells.prototype._ctrl_pressing_3_guard = function(parameters) {
    var keyCode = parameters[0];
    return parseInt(keyCode) == 17;
};

AreaSelectedCells.prototype._in_selecting_0_exec = function(parameters) {
    var x = parameters[0];
    var y = parameters[1];
    this.xB = gui.getRowBoundary(x, this.sheetOriginX,
    this.spreadSheetWidth, this.cellWidth);
    this.yB = gui.getColBoundary(y, this.sheetOriginY,
    this.spreadSheetHeight, this.cellHeight);
    if(this.xB >= 0 && this.yB >= 0)
    	this.rectangle = gui.drawAreaSelectedCells(this.sheetOriginX, this.sheetOriginY, this.mainField, this.xA, this.yA, this.xB, this.yB, this.cellWidth, this.cellHeight, this.rectangle);
};

AreaSelectedCells.prototype._in_selecting_1_exec = function(parameters) {
    var x = parameters[0];
    var y = parameters[1];
};

AreaSelectedCells.prototype.initializeStatechart = function() {
    // enter default state
    var states = this.states["/not_selecting"].getEffectiveTargetStates();
    this.updateConfiguration(states);
    for (var state_idx in states) {
        if (!states.hasOwnProperty(state_idx)) continue;
        var state = states[state_idx]
        if (state.enter) {
            state.enter();
        }
    }
};

// add symbol 'AreaSelectedCells' to package 'DSheet_GUI'
DSheet_GUI.AreaSelectedCells = AreaSelectedCells;

var SelectedCell = function(controller, cellWidth, cellHeight, columnsNumber, rowNumber, sheetOriginX, sheetOriginY, mainField, allSVGText) {
    RuntimeClassBase.call(this, controller);
    
    this.semantics.big_step_maximality = StatechartSemantics.TakeMany;
    this.semantics.internal_event_lifeline = StatechartSemantics.Queue;
    this.semantics.input_event_lifeline = StatechartSemantics.FirstComboStep;
    this.semantics.priority = StatechartSemantics.SourceParent;
    this.semantics.concurrency = StatechartSemantics.Single;
    
    // build Statechart structure
    this.build_statechart_structure();
    
    // user defined attributes
    this.cell = null;
    
    // call user defined constructor
    SelectedCell.prototype.user_defined_constructor.call(this, cellWidth, cellHeight, columnsNumber, rowNumber, sheetOriginX, sheetOriginY, mainField, allSVGText);
};
SelectedCell.prototype = new Object();
(function() {
    var proto = new RuntimeClassBase();
    for (prop in proto) {
        SelectedCell.prototype[prop] = proto[prop];
    }
})();

SelectedCell.prototype.user_defined_constructor = function(cellWidth, cellHeight, columnsNumber, rowNumber, sheetOriginX, sheetOriginY, mainField, allSVGText) {
    this.xCase = 0;
    this.yCase = 0;
    this.allSVGText = allSVGText;
    this.cell = gui.createSelectedCell(sheetOriginX, sheetOriginY,
    cellWidth, cellHeight, mainField);
    this.columnsNumber = columnsNumber;
    this.rowNumber = rowNumber;
    this.sheetOriginX = sheetOriginX;
    this.sheetOriginY = sheetOriginY;
    this.cellWidth = cellWidth;
    this.cellHeight = cellHeight;
    this.mainField = mainField;
    this.cursorPos = 0;
    this.svgText = {};
};

SelectedCell.prototype.user_defined_destructor = function() {
};


// user defined method
SelectedCell.prototype.leaveEditing = function() {
    xT = this.xCase*this.cellWidth;
    yT = this.yCase*this.cellHeight;
    var key = (xT)+'!'+(yT);
    this.allSVGText[key] = this.svgText;
    this.svgText = gui.cleanCell(this.svgText);
    this.cursorPos = 0;
};


// builds Statechart structure
SelectedCell.prototype.build_statechart_structure = function() {
    
    // state <root>
    this.states[""] = new State(0, this);
    
    // state /main
    this.states["/main"] = new State(1, this);
    
    // state /main/waiting_to_move
    this.states["/main/waiting_to_move"] = new State(2, this);
    this.states["/main/waiting_to_move"].setEnter(this._main_waiting_to_move_enter);
    
    // state /main/wait_for_edit
    this.states["/main/wait_for_edit"] = new State(3, this);
    this.states["/main/wait_for_edit"].setEnter(this._main_wait_for_edit_enter);
    this.states["/main/wait_for_edit"].setExit(this._main_wait_for_edit_exit);
    
    // state /editing_elsewhere
    this.states["/editing_elsewhere"] = new State(4, this);
    
    // add children
    this.states[""].addChild(this.states["/main"]);
    this.states[""].addChild(this.states["/editing_elsewhere"]);
    this.states["/main"].addChild(this.states["/main/waiting_to_move"]);
    this.states["/main"].addChild(this.states["/main/wait_for_edit"]);
    this.states[""].fixTree();
    this.states[""].default_state = this.states["/main"];
    this.states["/main"].default_state = this.states["/main/waiting_to_move"];
    
    // transition /main/waiting_to_move
    var _main_waiting_to_move_0 = new Transition(this, this.states["/main/waiting_to_move"], [this.states["/main/waiting_to_move"]]);
    _main_waiting_to_move_0.setAction(this._main_waiting_to_move_0_exec);
    _main_waiting_to_move_0.trigger = new Event("move", null);
    _main_waiting_to_move_0.setGuard(this._main_waiting_to_move_0_guard);
    this.states["/main/waiting_to_move"].addTransition(_main_waiting_to_move_0);
    var _main_waiting_to_move_1 = new Transition(this, this.states["/main/waiting_to_move"], [this.states["/main/waiting_to_move"]]);
    _main_waiting_to_move_1.setAction(this._main_waiting_to_move_1_exec);
    _main_waiting_to_move_1.trigger = new Event("bad_input", null);
    this.states["/main/waiting_to_move"].addTransition(_main_waiting_to_move_1);
    var _main_waiting_to_move_2 = new Transition(this, this.states["/main/waiting_to_move"], [this.states["/main/waiting_to_move"]]);
    _main_waiting_to_move_2.setAction(this._main_waiting_to_move_2_exec);
    _main_waiting_to_move_2.trigger = new Event("key_press", "ui");
    _main_waiting_to_move_2.setGuard(this._main_waiting_to_move_2_guard);
    this.states["/main/waiting_to_move"].addTransition(_main_waiting_to_move_2);
    var _main_waiting_to_move_3 = new Transition(this, this.states["/main/waiting_to_move"], [this.states["/main/wait_for_edit"]]);
    _main_waiting_to_move_3.setAction(this._main_waiting_to_move_3_exec);
    _main_waiting_to_move_3.trigger = new Event("key_press", "ui");
    _main_waiting_to_move_3.setGuard(this._main_waiting_to_move_3_guard);
    this.states["/main/waiting_to_move"].addTransition(_main_waiting_to_move_3);
    var _main_waiting_to_move_4 = new Transition(this, this.states["/main/waiting_to_move"], [this.states["/main/wait_for_edit"]]);
    _main_waiting_to_move_4.setAction(this._main_waiting_to_move_4_exec);
    _main_waiting_to_move_4.trigger = new Event("dbl_click", "ui");
    _main_waiting_to_move_4.setGuard(this._main_waiting_to_move_4_guard);
    this.states["/main/waiting_to_move"].addTransition(_main_waiting_to_move_4);
    
    // transition /main/wait_for_edit
    var _main_wait_for_edit_0 = new Transition(this, this.states["/main/wait_for_edit"], [this.states["/main/wait_for_edit"]]);
    _main_wait_for_edit_0.setAction(this._main_wait_for_edit_0_exec);
    _main_wait_for_edit_0.trigger = new Event("key_press", "ui");
    _main_wait_for_edit_0.setGuard(this._main_wait_for_edit_0_guard);
    this.states["/main/wait_for_edit"].addTransition(_main_wait_for_edit_0);
    var _main_wait_for_edit_1 = new Transition(this, this.states["/main/wait_for_edit"], [this.states["/main/waiting_to_move"]]);
    _main_wait_for_edit_1.setAction(this._main_wait_for_edit_1_exec);
    _main_wait_for_edit_1.trigger = new Event("key_press", "ui");
    _main_wait_for_edit_1.setGuard(this._main_wait_for_edit_1_guard);
    this.states["/main/wait_for_edit"].addTransition(_main_wait_for_edit_1);
    var _main_wait_for_edit_2 = new Transition(this, this.states["/main/wait_for_edit"], [this.states["/main/wait_for_edit"]]);
    _main_wait_for_edit_2.setAction(this._main_wait_for_edit_2_exec);
    _main_wait_for_edit_2.trigger = new Event("key_press", "ui");
    _main_wait_for_edit_2.setGuard(this._main_wait_for_edit_2_guard);
    this.states["/main/wait_for_edit"].addTransition(_main_wait_for_edit_2);
    var _main_wait_for_edit_3 = new Transition(this, this.states["/main/wait_for_edit"], [this.states["/main/waiting_to_move"]]);
    _main_wait_for_edit_3.setAction(this._main_wait_for_edit_3_exec);
    _main_wait_for_edit_3.trigger = new Event("key_press", "ui");
    _main_wait_for_edit_3.setGuard(this._main_wait_for_edit_3_guard);
    this.states["/main/wait_for_edit"].addTransition(_main_wait_for_edit_3);
    var _main_wait_for_edit_4 = new Transition(this, this.states["/main/wait_for_edit"], [this.states["/main/wait_for_edit"]]);
    _main_wait_for_edit_4.setAction(this._main_wait_for_edit_4_exec);
    _main_wait_for_edit_4.trigger = new Event("key_press", "ui");
    _main_wait_for_edit_4.setGuard(this._main_wait_for_edit_4_guard);
    this.states["/main/wait_for_edit"].addTransition(_main_wait_for_edit_4);
    var _main_wait_for_edit_5 = new Transition(this, this.states["/main/wait_for_edit"], [this.states["/main/waiting_to_move"]]);
    _main_wait_for_edit_5.setAction(this._main_wait_for_edit_5_exec);
    _main_wait_for_edit_5.trigger = new Event("key_press", "ui");
    _main_wait_for_edit_5.setGuard(this._main_wait_for_edit_5_guard);
    this.states["/main/wait_for_edit"].addTransition(_main_wait_for_edit_5);
    var _main_wait_for_edit_6 = new Transition(this, this.states["/main/wait_for_edit"], [this.states["/main/wait_for_edit"]]);
    _main_wait_for_edit_6.setAction(this._main_wait_for_edit_6_exec);
    _main_wait_for_edit_6.trigger = new Event("key_press", "ui");
    _main_wait_for_edit_6.setGuard(this._main_wait_for_edit_6_guard);
    this.states["/main/wait_for_edit"].addTransition(_main_wait_for_edit_6);
    
    // transition /editing_elsewhere
    var _editing_elsewhere_0 = new Transition(this, this.states["/editing_elsewhere"], [this.states["/main/waiting_to_move"]]);
    _editing_elsewhere_0.trigger = new Event("end_editing", null);
    this.states["/editing_elsewhere"].addTransition(_editing_elsewhere_0);
    
    // transition /main
    var _main_0 = new Transition(this, this.states["/main"], [this.states["/editing_elsewhere"]]);
    _main_0.trigger = new Event("editing", null);
    this.states["/main"].addTransition(_main_0);
};

SelectedCell.prototype._main_waiting_to_move_enter = function() {
    this.big_step.outputEventOM(new Event("narrow_cast", null, [this, 'parent/parent/wFormula', new Event("cell_moved", null, [this.xCase, this.yCase])]));
};

SelectedCell.prototype._main_wait_for_edit_enter = function() {
    // we put the cell in blue
    gui.changeColorCell(this.cell, "blue");
    this.big_step.outputEventOM(new Event("narrow_cast", null, [this, 'parent/parent/topBar', new Event("editing", null, new Array())]));
};

SelectedCell.prototype._main_wait_for_edit_exit = function() {
    this.big_step.outputEventOM(new Event("narrow_cast", null, [this, 'parent/parent/topBar', new Event("end_editing", null, new Array())]));
};

SelectedCell.prototype._main_waiting_to_move_0_exec = function(parameters) {
    var x = parameters[0];
    var y = parameters[1];
    //which case ?
    this.xCase = x;
    this.yCase = y;
    gui.moveElement(this.cell, this.xCase*this.cellWidth,
    this.yCase*this.cellHeight);
};

SelectedCell.prototype._main_waiting_to_move_0_guard = function(parameters) {
    var x = parameters[0];
    var y = parameters[1];
    return x>=0 && y>=0;
};

SelectedCell.prototype._main_waiting_to_move_1_exec = function(parameters) {
    var x = parameters[0];
    var y = parameters[1];
    // we put the cell in red
    gui.changeColorCell(this.cell, "red");
};

SelectedCell.prototype._main_waiting_to_move_2_exec = function(parameters) {
    var keyCode = parameters[0];
    if(parseInt(keyCode) == 38){
    this.yCase = this.yCase - 1;
    if(this.yCase < this.rowNumber && this.yCase >= 0)
    	gui.moveElement(this.cell, this.xCase*this.cellWidth, (this.yCase)*this.cellHeight);
    else
    	this.yCase = this.yCase + 1;
    }
    else if(parseInt(keyCode) == 40){
    this.yCase = this.yCase + 1;
    if(this.yCase < this.rowNumber && this.yCase >= 0)
    	gui.moveElement(this.cell, this.xCase*this.cellWidth,(this.yCase)*this.cellHeight);
    else
    	this.yCase = this.yCase - 1;
    }
    else if(parseInt(keyCode) == 37){
    this.xCase = this.xCase - 1;
    if(this.xCase < this.columnsNumber && this.xCase >= 0)
    	gui.moveElement(this.cell, this.xCase*this.cellWidth, (this.yCase)*this.cellHeight);
    else
    	this.xCase = this.xCase + 1;
    }
    else if(parseInt(keyCode) == 39){
    this.xCase = this.xCase + 1;
    if(this.xCase < this.columnsNumber && this.xCase >= 0)
    	gui.moveElement(this.cell, this.xCase*this.cellWidth, (this.yCase)*this.cellHeight);
    else
    	this.xCase = this.xCase - 1;
    }
};

SelectedCell.prototype._main_waiting_to_move_2_guard = function(parameters) {
    var keyCode = parameters[0];
    return (jQuery.inArray(parseInt(keyCode), [37, 38, 40, 39]) != -1);
};

SelectedCell.prototype._main_waiting_to_move_3_exec = function(parameters) {
    var keyCode = parameters[0];
    var xE = this.xCase*this.cellWidth;
    var yE = this.yCase*this.cellHeight;
    var retour = gui.createEditTextInput(this.sheetOriginX+this.cellWidth, this.sheetOriginY+this.cellHeight, this.cellHeight, this.mainField,
    xE, yE, gui.getTextSaved(xE, yE, this.allSVGText));
    this.cursorPos = retour[0];
    this.svgText = retour[1];
};

SelectedCell.prototype._main_waiting_to_move_3_guard = function(parameters) {
    var keyCode = parameters[0];
    return parseInt(keyCode)==13;
};

SelectedCell.prototype._main_waiting_to_move_4_exec = function(parameters) {
    var x = parameters[0];
    var y = parameters[1];
    var xE = this.xCase*this.cellWidth;
    var yE = this.yCase*this.cellHeight;
    var retour = gui.createEditTextInput(this.sheetOriginX+this.cellWidth, this.sheetOriginY+this.cellHeight, this.cellHeight, this.mainField,
    xE, yE, gui.getTextSaved(xE, yE, this.allSVGText));
    this.cursorPos = retour[0];
    this.svgText = retour[1];
};

SelectedCell.prototype._main_waiting_to_move_4_guard = function(parameters) {
    var x = parameters[0];
    var y = parameters[1];
    return gui.isIn(this.sheetOriginX, this.sheetOriginY, x,y,this.xCase*this.cellWidth,        this.yCase*this.cellHeight,        this.cellWidth, this.cellHeight);
};

SelectedCell.prototype._main_wait_for_edit_0_exec = function(parameters) {
    var keyCode = parameters[0];
    var text = String.fromCharCode(keyCode);
    this.cursorPos = gui.editTextInput(text, this.svgText, this.cursorPos);
};

SelectedCell.prototype._main_wait_for_edit_0_guard = function(parameters) {
    var keyCode = parameters[0];
    return (jQuery.inArray(parseInt(keyCode), [13, 8, 37, 38, 39, 40]) == -1);
};

SelectedCell.prototype._main_wait_for_edit_1_exec = function(parameters) {
    var keyCode = parameters[0];
    text = gui.getText(this.svgText);
    this.big_step.outputEventOM(new Event("narrow_cast", null, [this, 'parent/parent/messenger', new Event("input_text", null, [text, this.xCase, this.yCase])]));
    this.leaveEditing();
    this.yCase += 1;
    gui.moveElement(this.cell, this.xCase*this.cellWidth,
    (this.yCase)*this.cellHeight);
};

SelectedCell.prototype._main_wait_for_edit_1_guard = function(parameters) {
    var keyCode = parameters[0];
    return parseInt(keyCode)==13;
};

SelectedCell.prototype._main_wait_for_edit_2_exec = function(parameters) {
    var keyCode = parameters[0];
    this.cursorPos = 	gui.mooveCursor(this.svgText, this.cursorPos,-1);
};

SelectedCell.prototype._main_wait_for_edit_2_guard = function(parameters) {
    var keyCode = parameters[0];
    return parseInt(keyCode)==37;
};

SelectedCell.prototype._main_wait_for_edit_3_exec = function(parameters) {
    var keyCode = parameters[0];
    text = gui.getText(this.svgText);
    this.big_step.outputEventOM(new Event("narrow_cast", null, [this, 'parent/parent/messenger', new Event("input_text", null, [text, this.xCase, this.yCase])]));
    this.leaveEditing();
    this.yCase -= 1;
    gui.moveElement(this.cell, this.xCase*this.cellWidth,
    (this.yCase)*this.cellHeight);
};

SelectedCell.prototype._main_wait_for_edit_3_guard = function(parameters) {
    var keyCode = parameters[0];
    return parseInt(keyCode)==38;
};

SelectedCell.prototype._main_wait_for_edit_4_exec = function(parameters) {
    var keyCode = parameters[0];
    this.cursorPos = 	gui.mooveCursor(this.svgText, this.cursorPos,1);
};

SelectedCell.prototype._main_wait_for_edit_4_guard = function(parameters) {
    var keyCode = parameters[0];
    return parseInt(keyCode)==39;
};

SelectedCell.prototype._main_wait_for_edit_5_exec = function(parameters) {
    var keyCode = parameters[0];
    text = gui.getText(this.svgText);
    this.big_step.outputEventOM(new Event("narrow_cast", null, [this, 'parent/parent/messenger', new Event("input_text", null, [text, this.xCase, this.yCase])]));
    this.leaveEditing();
    this.yCase = this.yCase+1;
    gui.moveElement(this.cell, this.xCase*this.cellWidth,
    (this.yCase)*this.cellHeight);
};

SelectedCell.prototype._main_wait_for_edit_5_guard = function(parameters) {
    var keyCode = parameters[0];
    return parseInt(keyCode)==40;
};

SelectedCell.prototype._main_wait_for_edit_6_exec = function(parameters) {
    var keyCode = parameters[0];
    this.cursorPos = gui.deleteLastElementBeforeCursor(this.svgText, this.cursorPos);
};

SelectedCell.prototype._main_wait_for_edit_6_guard = function(parameters) {
    var keyCode = parameters[0];
    return parseInt(keyCode)==8 && this.cursorPos >0;
};

SelectedCell.prototype.initializeStatechart = function() {
    // enter default state
    var states = this.states["/main"].getEffectiveTargetStates();
    this.updateConfiguration(states);
    for (var state_idx in states) {
        if (!states.hasOwnProperty(state_idx)) continue;
        var state = states[state_idx]
        if (state.enter) {
            state.enter();
        }
    }
};

// add symbol 'SelectedCell' to package 'DSheet_GUI'
DSheet_GUI.SelectedCell = SelectedCell;

var Messenger = function(controller, columnsNumber, rowsNumber) {
    RuntimeClassBase.call(this, controller);
    
    this.semantics.big_step_maximality = StatechartSemantics.TakeMany;
    this.semantics.internal_event_lifeline = StatechartSemantics.Queue;
    this.semantics.input_event_lifeline = StatechartSemantics.FirstComboStep;
    this.semantics.priority = StatechartSemantics.SourceParent;
    this.semantics.concurrency = StatechartSemantics.Single;
    
    // build Statechart structure
    this.build_statechart_structure();
    
    // call user defined constructor
    Messenger.prototype.user_defined_constructor.call(this, columnsNumber, rowsNumber);
};
Messenger.prototype = new Object();
(function() {
    var proto = new RuntimeClassBase();
    for (prop in proto) {
        Messenger.prototype[prop] = proto[prop];
    }
})();

Messenger.prototype.user_defined_constructor = function(columnsNumber, rowsNumber) {
    // The constructor
    this.cellToDisplay = [];
    this.numberOfCellsToUpdate = 0;
    this.columnsNumber = columnsNumber;
    this.rowsNumber = rowsNumber;
    this.message2 = "";
    this.dateUpdate = -1;
    this.clientName = "default";
    this.connectionID = -1;
    this.error = "";
    this.listFileNames = {};
    this.responseLoad = "";
    this.responseDisconnect = "";
    this.disconnected = true;
};

Messenger.prototype.user_defined_destructor = function() {
};


// builds Statechart structure
Messenger.prototype.build_statechart_structure = function() {
    
    // state <root>
    this.states[""] = new State(0, this);
    
    // state /subscribing
    this.states["/subscribing"] = new State(1, this);
    this.states["/subscribing"].setEnter(this._subscribing_enter);
    this.states["/subscribing"].setExit(this._subscribing_exit);
    
    // state /waiting_confirmation
    this.states["/waiting_confirmation"] = new State(2, this);
    this.states["/waiting_confirmation"].setEnter(this._waiting_confirmation_enter);
    this.states["/waiting_confirmation"].setExit(this._waiting_confirmation_exit);
    
    // state /main
    this.states["/main"] = new ParallelState(3, this);
    
    // state /main/send_data
    this.states["/main/send_data"] = new State(4, this);
    
    // state /main/send_data/sending_data
    this.states["/main/send_data/sending_data"] = new State(5, this);
    
    // state /main/update
    this.states["/main/update"] = new State(6, this);
    
    // state /main/update/init_update_request
    this.states["/main/update/init_update_request"] = new State(7, this);
    this.states["/main/update/init_update_request"].setEnter(this._main_update_init_update_request_enter);
    this.states["/main/update/init_update_request"].setExit(this._main_update_init_update_request_exit);
    
    // state /main/update/waiting_to_update
    this.states["/main/update/waiting_to_update"] = new State(8, this);
    this.states["/main/update/waiting_to_update"].setEnter(this._main_update_waiting_to_update_enter);
    this.states["/main/update/waiting_to_update"].setExit(this._main_update_waiting_to_update_exit);
    
    // state /main/update/updating_connectionID
    this.states["/main/update/updating_connectionID"] = new State(9, this);
    
    // state /main/update/reporting_error
    this.states["/main/update/reporting_error"] = new State(10, this);
    
    // state /main/update/reporting_error_load
    this.states["/main/update/reporting_error_load"] = new State(11, this);
    
    // state /main/update/sending_files_to_load
    this.states["/main/update/sending_files_to_load"] = new State(12, this);
    
    // state /main/update/updatingCell
    this.states["/main/update/updatingCell"] = new State(13, this);
    this.states["/main/update/updatingCell"].setEnter(this._main_update_updatingCell_enter);
    
    // state /disconnected
    this.states["/disconnected"] = new State(14, this);
    
    // add children
    this.states[""].addChild(this.states["/subscribing"]);
    this.states[""].addChild(this.states["/waiting_confirmation"]);
    this.states[""].addChild(this.states["/main"]);
    this.states[""].addChild(this.states["/disconnected"]);
    this.states["/main"].addChild(this.states["/main/send_data"]);
    this.states["/main"].addChild(this.states["/main/update"]);
    this.states["/main/send_data"].addChild(this.states["/main/send_data/sending_data"]);
    this.states["/main/update"].addChild(this.states["/main/update/init_update_request"]);
    this.states["/main/update"].addChild(this.states["/main/update/waiting_to_update"]);
    this.states["/main/update"].addChild(this.states["/main/update/updating_connectionID"]);
    this.states["/main/update"].addChild(this.states["/main/update/reporting_error"]);
    this.states["/main/update"].addChild(this.states["/main/update/reporting_error_load"]);
    this.states["/main/update"].addChild(this.states["/main/update/sending_files_to_load"]);
    this.states["/main/update"].addChild(this.states["/main/update/updatingCell"]);
    this.states[""].fixTree();
    this.states[""].default_state = this.states["/subscribing"];
    this.states["/main/send_data"].default_state = this.states["/main/send_data/sending_data"];
    this.states["/main/update"].default_state = this.states["/main/update/init_update_request"];
    
    // transition /subscribing
    var _subscribing_0 = new Transition(this, this.states["/subscribing"], [this.states["/waiting_confirmation"]]);
    _subscribing_0.setAction(this._subscribing_0_exec);
    _subscribing_0.trigger = new Event("_0after");
    this.states["/subscribing"].addTransition(_subscribing_0);
    
    // transition /waiting_confirmation
    var _waiting_confirmation_0 = new Transition(this, this.states["/waiting_confirmation"], [this.states["/main"]]);
    _waiting_confirmation_0.setAction(this._waiting_confirmation_0_exec);
    _waiting_confirmation_0.setGuard(this._waiting_confirmation_0_guard);
    this.states["/waiting_confirmation"].addTransition(_waiting_confirmation_0);
    var _waiting_confirmation_1 = new Transition(this, this.states["/waiting_confirmation"], [this.states["/waiting_confirmation"]]);
    _waiting_confirmation_1.trigger = new Event("_1after");
    _waiting_confirmation_1.setGuard(this._waiting_confirmation_1_guard);
    this.states["/waiting_confirmation"].addTransition(_waiting_confirmation_1);
    
    // transition /main/send_data/sending_data
    var _main_send_data_sending_data_0 = new Transition(this, this.states["/main/send_data/sending_data"], [this.states["/main/send_data/sending_data"]]);
    _main_send_data_sending_data_0.setAction(this._main_send_data_sending_data_0_exec);
    _main_send_data_sending_data_0.trigger = new Event("input_text", null);
    this.states["/main/send_data/sending_data"].addTransition(_main_send_data_sending_data_0);
    var _main_send_data_sending_data_1 = new Transition(this, this.states["/main/send_data/sending_data"], [this.states["/main/send_data/sending_data"]]);
    _main_send_data_sending_data_1.setAction(this._main_send_data_sending_data_1_exec);
    _main_send_data_sending_data_1.trigger = new Event("copy_cut_past", null);
    this.states["/main/send_data/sending_data"].addTransition(_main_send_data_sending_data_1);
    var _main_send_data_sending_data_2 = new Transition(this, this.states["/main/send_data/sending_data"], [this.states["/main/send_data/sending_data"]]);
    _main_send_data_sending_data_2.setAction(this._main_send_data_sending_data_2_exec);
    _main_send_data_sending_data_2.trigger = new Event("redo", null);
    this.states["/main/send_data/sending_data"].addTransition(_main_send_data_sending_data_2);
    var _main_send_data_sending_data_3 = new Transition(this, this.states["/main/send_data/sending_data"], [this.states["/main/send_data/sending_data"]]);
    _main_send_data_sending_data_3.setAction(this._main_send_data_sending_data_3_exec);
    _main_send_data_sending_data_3.trigger = new Event("undo", null);
    this.states["/main/send_data/sending_data"].addTransition(_main_send_data_sending_data_3);
    var _main_send_data_sending_data_4 = new Transition(this, this.states["/main/send_data/sending_data"], [this.states["/main/send_data/sending_data"]]);
    _main_send_data_sending_data_4.setAction(this._main_send_data_sending_data_4_exec);
    _main_send_data_sending_data_4.trigger = new Event("save", null);
    this.states["/main/send_data/sending_data"].addTransition(_main_send_data_sending_data_4);
    var _main_send_data_sending_data_5 = new Transition(this, this.states["/main/send_data/sending_data"], [this.states["/main/send_data/sending_data"]]);
    _main_send_data_sending_data_5.setAction(this._main_send_data_sending_data_5_exec);
    _main_send_data_sending_data_5.trigger = new Event("disconnect", null);
    this.states["/main/send_data/sending_data"].addTransition(_main_send_data_sending_data_5);
    var _main_send_data_sending_data_6 = new Transition(this, this.states["/main/send_data/sending_data"], [this.states["/main/send_data/sending_data"]]);
    _main_send_data_sending_data_6.setAction(this._main_send_data_sending_data_6_exec);
    _main_send_data_sending_data_6.trigger = new Event("load", null);
    this.states["/main/send_data/sending_data"].addTransition(_main_send_data_sending_data_6);
    var _main_send_data_sending_data_7 = new Transition(this, this.states["/main/send_data/sending_data"], [this.states["/main/send_data/sending_data"]]);
    _main_send_data_sending_data_7.setAction(this._main_send_data_sending_data_7_exec);
    _main_send_data_sending_data_7.trigger = new Event("askFilesToLoad", null);
    this.states["/main/send_data/sending_data"].addTransition(_main_send_data_sending_data_7);
    
    // transition /main/update/init_update_request
    var _main_update_init_update_request_0 = new Transition(this, this.states["/main/update/init_update_request"], [this.states["/main/update/waiting_to_update"]]);
    _main_update_init_update_request_0.setAction(this._main_update_init_update_request_0_exec);
    _main_update_init_update_request_0.trigger = new Event("_2after");
    this.states["/main/update/init_update_request"].addTransition(_main_update_init_update_request_0);
    
    // transition /main/update/waiting_to_update
    var _main_update_waiting_to_update_0 = new Transition(this, this.states["/main/update/waiting_to_update"], [this.states["/main/update/updatingCell"]]);
    _main_update_waiting_to_update_0.setAction(this._main_update_waiting_to_update_0_exec);
    _main_update_waiting_to_update_0.setGuard(this._main_update_waiting_to_update_0_guard);
    this.states["/main/update/waiting_to_update"].addTransition(_main_update_waiting_to_update_0);
    var _main_update_waiting_to_update_1 = new Transition(this, this.states["/main/update/waiting_to_update"], [this.states["/main/update/sending_files_to_load"]]);
    _main_update_waiting_to_update_1.setAction(this._main_update_waiting_to_update_1_exec);
    _main_update_waiting_to_update_1.setGuard(this._main_update_waiting_to_update_1_guard);
    this.states["/main/update/waiting_to_update"].addTransition(_main_update_waiting_to_update_1);
    var _main_update_waiting_to_update_2 = new Transition(this, this.states["/main/update/waiting_to_update"], [this.states["/main/update/reporting_error_load"]]);
    _main_update_waiting_to_update_2.setAction(this._main_update_waiting_to_update_2_exec);
    _main_update_waiting_to_update_2.setGuard(this._main_update_waiting_to_update_2_guard);
    this.states["/main/update/waiting_to_update"].addTransition(_main_update_waiting_to_update_2);
    var _main_update_waiting_to_update_3 = new Transition(this, this.states["/main/update/waiting_to_update"], [this.states["/disconnected"]]);
    _main_update_waiting_to_update_3.setAction(this._main_update_waiting_to_update_3_exec);
    _main_update_waiting_to_update_3.setGuard(this._main_update_waiting_to_update_3_guard);
    this.states["/main/update/waiting_to_update"].addTransition(_main_update_waiting_to_update_3);
    var _main_update_waiting_to_update_4 = new Transition(this, this.states["/main/update/waiting_to_update"], [this.states["/main/update/updating_connectionID"]]);
    _main_update_waiting_to_update_4.setAction(this._main_update_waiting_to_update_4_exec);
    _main_update_waiting_to_update_4.setGuard(this._main_update_waiting_to_update_4_guard);
    this.states["/main/update/waiting_to_update"].addTransition(_main_update_waiting_to_update_4);
    var _main_update_waiting_to_update_5 = new Transition(this, this.states["/main/update/waiting_to_update"], [this.states["/main/update/reporting_error"]]);
    _main_update_waiting_to_update_5.setAction(this._main_update_waiting_to_update_5_exec);
    _main_update_waiting_to_update_5.setGuard(this._main_update_waiting_to_update_5_guard);
    this.states["/main/update/waiting_to_update"].addTransition(_main_update_waiting_to_update_5);
    var _main_update_waiting_to_update_6 = new Transition(this, this.states["/main/update/waiting_to_update"], [this.states["/main/update/waiting_to_update"]]);
    _main_update_waiting_to_update_6.setAction(this._main_update_waiting_to_update_6_exec);
    _main_update_waiting_to_update_6.trigger = new Event("_3after");
    _main_update_waiting_to_update_6.setGuard(this._main_update_waiting_to_update_6_guard);
    this.states["/main/update/waiting_to_update"].addTransition(_main_update_waiting_to_update_6);
    
    // transition /main/update/updating_connectionID
    var _main_update_updating_connectionID_0 = new Transition(this, this.states["/main/update/updating_connectionID"], [this.states["/main/update/waiting_to_update"]]);
    this.states["/main/update/updating_connectionID"].addTransition(_main_update_updating_connectionID_0);
    
    // transition /main/update/reporting_error
    var _main_update_reporting_error_0 = new Transition(this, this.states["/main/update/reporting_error"], [this.states["/main/update/waiting_to_update"]]);
    this.states["/main/update/reporting_error"].addTransition(_main_update_reporting_error_0);
    
    // transition /main/update/reporting_error_load
    var _main_update_reporting_error_load_0 = new Transition(this, this.states["/main/update/reporting_error_load"], [this.states["/main/update/waiting_to_update"]]);
    this.states["/main/update/reporting_error_load"].addTransition(_main_update_reporting_error_load_0);
    
    // transition /main/update/sending_files_to_load
    var _main_update_sending_files_to_load_0 = new Transition(this, this.states["/main/update/sending_files_to_load"], [this.states["/main/update/waiting_to_update"]]);
    _main_update_sending_files_to_load_0.setAction(this._main_update_sending_files_to_load_0_exec);
    _main_update_sending_files_to_load_0.trigger = new Event("filesToLoadDisplayed", null);
    this.states["/main/update/sending_files_to_load"].addTransition(_main_update_sending_files_to_load_0);
    
    // transition /main/update/updatingCell
    var _main_update_updatingCell_0 = new Transition(this, this.states["/main/update/updatingCell"], [this.states["/main/update/updatingCell"]]);
    _main_update_updatingCell_0.setAction(this._main_update_updatingCell_0_exec);
    _main_update_updatingCell_0.setGuard(this._main_update_updatingCell_0_guard);
    this.states["/main/update/updatingCell"].addTransition(_main_update_updatingCell_0);
    var _main_update_updatingCell_1 = new Transition(this, this.states["/main/update/updatingCell"], [this.states["/main/update/waiting_to_update"]]);
    _main_update_updatingCell_1.setAction(this._main_update_updatingCell_1_exec);
    _main_update_updatingCell_1.setGuard(this._main_update_updatingCell_1_guard);
    this.states["/main/update/updatingCell"].addTransition(_main_update_updatingCell_1);
};

Messenger.prototype._subscribing_enter = function() {
    this.addTimer(0, 0.1);
};

Messenger.prototype._subscribing_exit = function() {
    this.removeTimer(0);
};

Messenger.prototype._waiting_confirmation_enter = function() {
    this.addTimer(1, 1);
};

Messenger.prototype._waiting_confirmation_exit = function() {
    this.removeTimer(1);
};

Messenger.prototype._main_update_init_update_request_enter = function() {
    this.addTimer(2, 0.1);
};

Messenger.prototype._main_update_init_update_request_exit = function() {
    this.removeTimer(2);
};

Messenger.prototype._main_update_waiting_to_update_enter = function() {
    this.addTimer(3, 0.05);
};

Messenger.prototype._main_update_waiting_to_update_exit = function() {
    this.removeTimer(3);
};

Messenger.prototype._main_update_updatingCell_enter = function() {
    this.numberOfCellsToUpdate = 0;
};

Messenger.prototype._subscribing_0_exec = function(parameters) {
    var message = '{';
    message += '"request": "acceptData"';
    message += ','+'"option": "subscribe"';
    message += '}';
    
    $.ajax({ url: "main_page.html", success: function(data){
    
    this.clientName = data["clientName"];
    this.connectionID = data["connectionID"];
    
    }.bind(this)
    , dataType: "json",method: "POST", data: message});
};

Messenger.prototype._waiting_confirmation_0_exec = function(parameters) {
    this.disconnected = false;
    console.log("messenger start");
    this.big_step.outputEventOM(new Event("narrow_cast", null, [this, 'parent/topBar', new Event("update_connectionID", null, [this.connectionID, this.clientName])]));
};

Messenger.prototype._waiting_confirmation_0_guard = function(parameters) {
    return this.clientName != 'default'      && this.connectionID != -1;
};

Messenger.prototype._waiting_confirmation_1_guard = function(parameters) {
    return this.clientName == 'default';
};

Messenger.prototype._main_send_data_sending_data_0_exec = function(parameters) {
    var data = parameters[0];
    var xCase = parameters[1];
    var yCase = parameters[2];
    // we send the input to the server
    var message = '{';
    message += '"request": "acceptData"';
    message += ','+'"option": "input_text"';
    message += ','+'"data": "'+data+'"';
    message += ','+'"x": "'+xCase+'"';
    message += ','+'"y": "'+yCase+'"';
    message += '}';
    
    $.post( "main_page.html", message,function( data ) {
    this.error = data['badInput'];
    this.xError = data['xError'];
    this.yError = data['yError'];
    }.bind(this), "json");
};

Messenger.prototype._main_send_data_sending_data_1_exec = function(parameters) {
    var option = parameters[0];
    var xA = parameters[1];
    var yA = parameters[2];
    var xB = parameters[3];
    var yB = parameters[4];
    var message = '{';
    message += '"request": "acceptData"';
    message += ','+'"option": "'+option+'"';
    message += ','+'"xA": "'+xA+'"';
    message += ','+'"yA": "'+yA+'"';
    message += ','+'"xB": "'+xB+'"';
    message += ','+'"yB": "'+yB+'"';
    message += '}';
    
    $.post( "main_page.html", message);
};

Messenger.prototype._main_send_data_sending_data_2_exec = function(parameters) {
    var message = '{';
    message += '"request": "acceptData"';
    message += ','+'"option": "redo"';
    message += '}';
    
    $.post( "main_page.html", message);
};

Messenger.prototype._main_send_data_sending_data_3_exec = function(parameters) {
    var message = '{';
    message += '"request": "acceptData"';
    message += ','+'"option": "undo"';
    message += '}';
    
    $.post( "main_page.html", message);
};

Messenger.prototype._main_send_data_sending_data_4_exec = function(parameters) {
    var text = parameters[0];
    var message = '{';
    message += '"request": "acceptData"';
    message += ','+'"option": "save"';
    message += ','+'"fileName": "'+text+'"';
    message += '}';
    
    $.post( "main_page.html", message);
};

Messenger.prototype._main_send_data_sending_data_5_exec = function(parameters) {
    var message = '{';
    message += '"request": "acceptData"';
    message += ','+'"option": "disconnect"';
    message += ','+'"clientName": "'+this.clientName+'"';
    message += '}';
    
    $.ajax({ url: "main_page.html", success: function(data){
    
    this.responseDisconnect = data["response"];
    
    }.bind(this)
    , dataType: "json",method: "POST", data: message});
};

Messenger.prototype._main_send_data_sending_data_6_exec = function(parameters) {
    var text = parameters[0];
    var message = '{';
    message += '"request": "acceptData"';
    message += ','+'"option": "load"';
    message += ','+'"fileName": "'+text+'"';
    message += '}';
    
    $.ajax({ url: "main_page.html", success: function(data){
    
    this.responseLoad = data["response"];
    
    }.bind(this)
    , dataType: "json",method: "POST", data: message});
};

Messenger.prototype._main_send_data_sending_data_7_exec = function(parameters) {
    var message = '{';
    message += '"request": "acceptData"';
    message += ','+'"option": "filesToLoad"';
    message += '}';
    
    $.ajax({ url: "main_page.html", success: function(data){
    this.listFileNames = data["response"];
    
    }.bind(this)
    , dataType: "json",method: "POST", data: message});
};

Messenger.prototype._main_update_init_update_request_0_exec = function(parameters) {
    // the message
    this.message2 = '{';
    this.message2 += '"request": "update"';
    this.message2 += ','+'"width": "'+this.columnsNumber+'"';
    this.message2 += ','+'"height": "'+this.rowsNumber+'"';
    this.message2 += ','+'"dateUpdate": "'+this.dateUpdate+'"';
    this.message2 += ','+'"clientName": "'+this.clientName+'"';
    this.message2 += '}';
    
    (function poll(){
    if(!this.disconnected){
    $.ajax({ url: "main_page.html", success: function(data){
    
    
    // data is already in JSON
    if(data['request']== "update"){
      if(data.update == "yes"){
        // we get the data:
        var width = data.width;
        var height = data.height;
        this.connectionIDServer = data.connectionID;
        var key = "";
        // a list of object with the attributs: x, y, value
        var cells = [];
        this.numberOfCellsToUpdate = data.cellToUpdateX.length;
    
        this.dateUpdate = data.dateUpdate;
    		this.clientNameServer = data.clientName;
    		console.log("last update:"+ this.dateUpdate);
        for(i=0; i<this.numberOfCellsToUpdate; i++){
    
          var cell = {};
          cell.x = data.cellToUpdateX[i];
          cell.y = data.cellToUpdateY[i];
          key= data.cellToUpdateX[i]+"!"+data.cellToUpdateY[i];
          // the first one is the value
          cell.val = data[key][0];
          cell.formula = data[key][1];
          cells.push(cell);
    
        }
    
        // attribute so other states can access to it easily
        this.cellToUpdate = cells;
      }
      }
    
    	// the message
    	this.message2 = '{';
    	this.message2 += '"request": "update"';
    	this.message2 += ','+'"width": "'+this.columnsNumber+'"';
    	this.message2 += ','+'"height": "'+this.rowsNumber+'"';
    	this.message2 += ','+'"dateUpdate": "'+this.dateUpdate+'"';
    	this.message2 += ','+'"clientName": "'+this.clientNameServer+'"';
    	this.message2 += '}';
    
    }.bind(this)
    , dataType: "json", complete: poll.bind(this), timeout: 10000 ,method: "POST", data: this.message2});
    }
    }).bind(this)();
};

Messenger.prototype._main_update_waiting_to_update_0_exec = function(parameters) {
    this.counter = this.numberOfCellsToUpdate
};

Messenger.prototype._main_update_waiting_to_update_0_guard = function(parameters) {
    return this.numberOfCellsToUpdate>0;
};

Messenger.prototype._main_update_waiting_to_update_1_exec = function(parameters) {
    this.big_step.outputEventOM(new Event("narrow_cast", null, [this, 'parent/topBar', new Event("filesToLoad", null, [this.listFileNames])]));
};

Messenger.prototype._main_update_waiting_to_update_1_guard = function(parameters) {
    return !jQuery.isEmptyObject(this.listFileNames);
};

Messenger.prototype._main_update_waiting_to_update_2_exec = function(parameters) {
    this.responseLoad = "";
    this.big_step.outputEventOM(new Event("narrow_cast", null, [this, 'parent/topBar', new Event("errorLoad", null, new Array())]));
};

Messenger.prototype._main_update_waiting_to_update_2_guard = function(parameters) {
    return this.responseLoad == 'not ok';
};

Messenger.prototype._main_update_waiting_to_update_3_exec = function(parameters) {
    this.disconnected = true;
    this.responseDisconnect = "";
    this.big_step.outputEventOM(new Event("narrow_cast", null, [this, 'parent/topBar', new Event("disconnected", null, new Array())]));
};

Messenger.prototype._main_update_waiting_to_update_3_guard = function(parameters) {
    return this.responseDisconnect == 'disconnected';
};

Messenger.prototype._main_update_waiting_to_update_4_exec = function(parameters) {
    this.connectionID = this.connectionIDServer;
    this.clientName = this.clientNameServer;
    this.big_step.outputEventOM(new Event("narrow_cast", null, [this, 'parent/topBar', new Event("update_connectionID", null, [this.connectionID, this.clientName])]));
};

Messenger.prototype._main_update_waiting_to_update_4_guard = function(parameters) {
    return this.connectionID != this.connectionIDServer || this.clientName != this.clientNameServer;
};

Messenger.prototype._main_update_waiting_to_update_5_exec = function(parameters) {
    this.big_step.outputEventOM(new Event("narrow_cast", null, [this, 'parent/spreadSheet', new Event("bad_input", null, [this.xError, this.yError, this.error])]));
    this.big_step.outputEventOM(new Event("narrow_cast", null, [this, 'parent/spreadSheet/selectedCell', new Event("bad_input", null, [this.xError, this.yError])]));
    this.error = "";
    this.xError = -1;
    this.yError = -1;
};

Messenger.prototype._main_update_waiting_to_update_5_guard = function(parameters) {
    return this.error != '';
};

Messenger.prototype._main_update_waiting_to_update_6_exec = function(parameters) {
};

Messenger.prototype._main_update_waiting_to_update_6_guard = function(parameters) {
    return this.error == '' && this.connectionID == this.connectionIDServer         && this.numberOfCellsToUpdate==0 && jQuery.isEmptyObject(this.listFileNames)         &&  this.responseLoad != 'not ok';
};

Messenger.prototype._main_update_sending_files_to_load_0_exec = function(parameters) {
    this.listFileNames = {};
};

Messenger.prototype._main_update_updatingCell_0_exec = function(parameters) {
    var x= this.cellToUpdate[this.cellToUpdate.length- this.counter].x;
    var y = this.cellToUpdate[this.cellToUpdate.length- this.counter].y;
    var val = this.cellToUpdate[this.cellToUpdate.length- this.counter].val;
    var formula = this.cellToUpdate[this.cellToUpdate.length- this.counter].formula;
    this.counter -=1;
    console.log("we are going to update this cell dude ! "
    + "x: "+x+"y: "+y+"val: "+val+" formula: "+formula);
    this.big_step.outputEventOM(new Event("narrow_cast", null, [this, 'parent/spreadSheet', new Event("updateTextCell", null, [x, y, val])]));
    this.big_step.outputEventOM(new Event("narrow_cast", null, [this, 'parent/wFormula', new Event("new_formula", null, [x, y, formula])]));
};

Messenger.prototype._main_update_updatingCell_0_guard = function(parameters) {
    return this.counter>0;
};

Messenger.prototype._main_update_updatingCell_1_exec = function(parameters) {
    this.counter = -1;
};

Messenger.prototype._main_update_updatingCell_1_guard = function(parameters) {
    return this.counter==0;
};

Messenger.prototype.initializeStatechart = function() {
    // enter default state
    var states = this.states["/subscribing"].getEffectiveTargetStates();
    this.updateConfiguration(states);
    for (var state_idx in states) {
        if (!states.hasOwnProperty(state_idx)) continue;
        var state = states[state_idx]
        if (state.enter) {
            state.enter();
        }
    }
};

// add symbol 'Messenger' to package 'DSheet_GUI'
DSheet_GUI.Messenger = Messenger;

var ObjectManager = function(controller) {
    ObjectManagerBase.call(this, controller);
};
ObjectManager.prototype = new Object();
(function() {
    var proto = new ObjectManagerBase();
    for (prop in proto) {
        ObjectManager.prototype[prop] = proto[prop];
    }
})();

ObjectManager.prototype.instantiate = function(class_name, construct_params) {
    if (class_name === "MainWindow") {
        var instance = new MainWindow(this.controller);
        instance.associations = new Object();
        instance.associations["spreadSheet"] = new Association("SpreadSheet", 0, -1);
        instance.associations["messenger"] = new Association("Messenger", 1, 1);
        instance.associations["wFormula"] = new Association("WFormula", 1, 1);
        instance.associations["topBar"] = new Association("TopBar", 1, 1);
    } else if (class_name === "WFormula") {
        var instance = new WFormula(this.controller, construct_params[0], construct_params[1], construct_params[2], construct_params[3], construct_params[4]);
        instance.associations = new Object();
        instance.associations["parent"] = new Association("MainWindow", 1, 1);
    } else if (class_name === "TopBar") {
        var instance = new TopBar(this.controller, construct_params[0], construct_params[1], construct_params[2], construct_params[3], construct_params[4]);
        instance.associations = new Object();
        instance.associations["parent"] = new Association("MainWindow", 1, 1);
    } else if (class_name === "SpreadSheet") {
        var instance = new SpreadSheet(this.controller, construct_params[0], construct_params[1], construct_params[2], construct_params[3], construct_params[4], construct_params[5], construct_params[6], construct_params[7], construct_params[8]);
        instance.associations = new Object();
        instance.associations["selectedCell"] = new Association("SelectedCell", 0, -1);
        instance.associations["areaSelectedCells"] = new Association("AreaSelectedCells", 0, -1);
        instance.associations["parent"] = new Association("MainWindow", 1, 1);
    } else if (class_name === "AreaSelectedCells") {
        var instance = new AreaSelectedCells(this.controller, construct_params[0], construct_params[1], construct_params[2], construct_params[3], construct_params[4], construct_params[5], construct_params[6]);
        instance.associations = new Object();
        instance.associations["parent"] = new Association("SpreadSheet", 1, 1);
    } else if (class_name === "SelectedCell") {
        var instance = new SelectedCell(this.controller, construct_params[0], construct_params[1], construct_params[2], construct_params[3], construct_params[4], construct_params[5], construct_params[6], construct_params[7]);
        instance.associations = new Object();
        instance.associations["parent"] = new Association("SpreadSheet", 1, 1);
    } else if (class_name === "Messenger") {
        var instance = new Messenger(this.controller, construct_params[0], construct_params[1]);
        instance.associations = new Object();
        instance.associations["parent"] = new Association("MainWindow", 1, 1);
    } else  {
        throw new Error("Cannot instantiate class " + class_name);
    }
    return instance;
};

// add symbol 'ObjectManager' to package 'DSheet_GUI'
DSheet_GUI.ObjectManager = ObjectManager;

var Controller = function(event_loop_callbacks, finished_callback) {
    if (finished_callback === undefined) finished_callback = null;
    EventLoopControllerBase.call(this, new ObjectManager(this), event_loop_callbacks, finished_callback);
    this.addInputPort("ui");
    this.object_manager.createInstance("MainWindow", new Array());
};
Controller.prototype = new Object();
(function() {
    var proto = new EventLoopControllerBase();
    for (prop in proto) {
        Controller.prototype[prop] = proto[prop];
    }
})();

// add symbol 'Controller' to package 'DSheet_GUI'
DSheet_GUI.Controller = Controller;
})();