
import sys
# TODO change into relative path
sys.path.insert(0, "DSheet/prototype4")

from threading import Thread
import server
from sccd.runtime.statecharts_core import Event
import threading
import time
import Tkinter as tk
import socket2event
from DSheet import DSheet

def ctrlCQuit(thread_server):
  """
  Handle SIGINT signal: exit() application
  """
  # we may wish to put cleanup actions here
  print "Spreadsheet Application was closed (by SIGINT signal)"
  print "We end the server also"
  thread_server.stop()
  thread_server.join()
  sys.exit()


# We can not kill a thread in python so this class (from the web)
class StoppableThread(threading.Thread):
    """Thread class with a stop() method. The thread itself has to check
    regularly for the stopped() condition."""

    def __init__(self, subject):
        super(StoppableThread, self).__init__()
        self._subject = subject
        self._controller = None

    def stop(self):
        if(self._controller != None):
            self._controller.stop()

    def start_server(self,subject):
        parameters = []
        parameters.append(subject)
        if(len(sys.argv)>1):
            for i in range(1, len(sys.argv)):
                parameters.append(sys.argv[i])

        self._controller = server.Controller(parameters)

        socket2event.boot_translation_service(self._controller)

        self._controller.start()

    def run(self):
        self.start_server(self._subject)

if __name__ == '__main__':

    # to use the desktop DSheet
    root = tk.Tk()
    root.withdraw()

    mainApp=DSheet(root)
    subject = mainApp.createSubject()

    #start the server on a different thread, so we can launch the desktop application
    #Tkinter want to be the main thread
    thread = StoppableThread(subject)
    thread.start()

    #start the desktop application (for development purpose)
    mainApp.addGridViewObserver(subject)
    try:
      root.mainloop()
    except KeyboardInterrupt:
      ctrlCQuit(thread)
