"""
Generated by Statechart compiler by Glenn De Jonghe, Joeri Exelmans, Simon Van Mierlo, and Yentl Van Tendeloo (for the inspiration)

Date:   Sun Sep  4 17:46:23 2016

Model author: Yentl Van Tendeloo and a little bit of Julien Tomezach (BackEnd)
Model name:   HTTP Server
Model description:
Server which handle the request of the DSheet client(s)
"""

from sccd.runtime.statecharts_core import *
import time
import os
import urllib
import sys
import logging

# For BackEnd
from BackEndAPI import *

# package "HTTP Server"

class BackEnd(RuntimeClassBase):
    def __init__(self, controller, params):
        RuntimeClassBase.__init__(self, controller)
        
        self.semantics.big_step_maximality = StatechartSemantics.TakeMany
        self.semantics.internal_event_lifeline = StatechartSemantics.Queue
        self.semantics.input_event_lifeline = StatechartSemantics.FirstComboStep
        self.semantics.priority = StatechartSemantics.SourceParent
        self.semantics.concurrency = StatechartSemantics.Single
        
        # build Statechart structure
        self.build_statechart_structure()
        
        # call user defined constructor
        BackEnd.user_defined_constructor(self, params)
    
    def user_defined_constructor(self, params):
        if(len(params)>2):
          self.address = str(params[1])
          self.port = int(params[2])
        elif(len(params)>1):
          self.address = "localhost"
          self.port = int(params[1])
        else:
          self.address = "localhost"
          self.port = 8080
        
        
        logging.basicConfig(filename="log.txt",level=logging.INFO)
        
        self.source = None
        self.dataClient = {}
        self.notifyChanged = False
        self.sendUpdate = False
        self.response = None
        self.sendIt = False
        self.counterClient = 0
        
        self.clientNames = []
        
        
        # we register to the subject
        self.subject = params[0]
        self.subject.attach(self)
    
    def user_defined_destructor(self):
        pass
    
    
    # user defined method
    def notify(self):
        logging.info("Server: I have been notified of a change")
        print "Server: I have been notified of a change"
        self.notifyChanged = True
    
    
    # builds Statechart structure
    def build_statechart_structure(self):
        
        # state <root>
        self.states[""] = State(0, self)
        
        # state /init_server
        self.states["/init_server"] = State(1, self)
        self.states["/init_server"].setEnter(self._init_server_enter)
        
        # state /backend_behaviour
        self.states["/backend_behaviour"] = ParallelState(2, self)
        
        # state /backend_behaviour/respondToClients
        self.states["/backend_behaviour/respondToClients"] = State(3, self)
        
        # state /backend_behaviour/respondToClients/wait_for_requests
        self.states["/backend_behaviour/respondToClients/wait_for_requests"] = State(4, self)
        
        # state /backend_behaviour/respondToClients/processing_request
        self.states["/backend_behaviour/respondToClients/processing_request"] = State(5, self)
        self.states["/backend_behaviour/respondToClients/processing_request"].setEnter(self._backend_behaviour_respondToClients_processing_request_enter)
        
        # state /backend_behaviour/updateClients
        self.states["/backend_behaviour/updateClients"] = State(6, self)
        
        # state /backend_behaviour/updateClients/main
        self.states["/backend_behaviour/updateClients/main"] = State(7, self)
        self.states["/backend_behaviour/updateClients/main"].setEnter(self._backend_behaviour_updateClients_main_enter)
        self.states["/backend_behaviour/updateClients/main"].setExit(self._backend_behaviour_updateClients_main_exit)
        
        # add children
        self.states[""].addChild(self.states["/init_server"])
        self.states[""].addChild(self.states["/backend_behaviour"])
        self.states["/backend_behaviour"].addChild(self.states["/backend_behaviour/respondToClients"])
        self.states["/backend_behaviour"].addChild(self.states["/backend_behaviour/updateClients"])
        self.states["/backend_behaviour/respondToClients"].addChild(self.states["/backend_behaviour/respondToClients/wait_for_requests"])
        self.states["/backend_behaviour/respondToClients"].addChild(self.states["/backend_behaviour/respondToClients/processing_request"])
        self.states["/backend_behaviour/updateClients"].addChild(self.states["/backend_behaviour/updateClients/main"])
        self.states[""].fixTree()
        self.states[""].default_state = self.states["/init_server"]
        self.states["/backend_behaviour/respondToClients"].default_state = self.states["/backend_behaviour/respondToClients/wait_for_requests"]
        self.states["/backend_behaviour/updateClients"].default_state = self.states["/backend_behaviour/updateClients/main"]
        
        # transition /init_server
        _init_server_0 = Transition(self, self.states["/init_server"], [self.states["/backend_behaviour"]])
        _init_server_0.setAction(self._init_server_0_exec)
        _init_server_0.trigger = Event("instance_created", None)
        self.states["/init_server"].addTransition(_init_server_0)
        
        # transition /backend_behaviour/respondToClients/wait_for_requests
        _backend_behaviour_respondToClients_wait_for_requests_0 = Transition(self, self.states["/backend_behaviour/respondToClients/wait_for_requests"], [self.states["/backend_behaviour/respondToClients/processing_request"]])
        _backend_behaviour_respondToClients_wait_for_requests_0.setAction(self._backend_behaviour_respondToClients_wait_for_requests_0_exec)
        _backend_behaviour_respondToClients_wait_for_requests_0.trigger = Event("HTTP_output", None)
        self.states["/backend_behaviour/respondToClients/wait_for_requests"].addTransition(_backend_behaviour_respondToClients_wait_for_requests_0)
        
        # transition /backend_behaviour/respondToClients/processing_request
        _backend_behaviour_respondToClients_processing_request_0 = Transition(self, self.states["/backend_behaviour/respondToClients/processing_request"], [self.states["/backend_behaviour/respondToClients/wait_for_requests"]])
        _backend_behaviour_respondToClients_processing_request_0.setGuard(self._backend_behaviour_respondToClients_processing_request_0_guard)
        self.states["/backend_behaviour/respondToClients/processing_request"].addTransition(_backend_behaviour_respondToClients_processing_request_0)
        _backend_behaviour_respondToClients_processing_request_1 = Transition(self, self.states["/backend_behaviour/respondToClients/processing_request"], [self.states["/backend_behaviour/respondToClients/wait_for_requests"]])
        _backend_behaviour_respondToClients_processing_request_1.setAction(self._backend_behaviour_respondToClients_processing_request_1_exec)
        _backend_behaviour_respondToClients_processing_request_1.setGuard(self._backend_behaviour_respondToClients_processing_request_1_guard)
        self.states["/backend_behaviour/respondToClients/processing_request"].addTransition(_backend_behaviour_respondToClients_processing_request_1)
        
        # transition /backend_behaviour/updateClients/main
        _backend_behaviour_updateClients_main_0 = Transition(self, self.states["/backend_behaviour/updateClients/main"], [self.states["/backend_behaviour/updateClients/main"]])
        _backend_behaviour_updateClients_main_0.setAction(self._backend_behaviour_updateClients_main_0_exec)
        _backend_behaviour_updateClients_main_0.trigger = Event("_0after")
        _backend_behaviour_updateClients_main_0.setGuard(self._backend_behaviour_updateClients_main_0_guard)
        self.states["/backend_behaviour/updateClients/main"].addTransition(_backend_behaviour_updateClients_main_0)
        _backend_behaviour_updateClients_main_1 = Transition(self, self.states["/backend_behaviour/updateClients/main"], [self.states["/backend_behaviour/updateClients/main"]])
        _backend_behaviour_updateClients_main_1.trigger = Event("_1after")
        _backend_behaviour_updateClients_main_1.setGuard(self._backend_behaviour_updateClients_main_1_guard)
        self.states["/backend_behaviour/updateClients/main"].addTransition(_backend_behaviour_updateClients_main_1)
    
    def _init_server_enter(self):
        temp = "*******************************"
        msg = "New Instance of Server"
        logging.info(temp+msg+temp)
        print temp+msg+temp
        self.big_step.outputEventOM(Event("create_instance", None, [self, 'to_server', 'Server', self.address, self.port]))
    
    def _backend_behaviour_respondToClients_processing_request_enter(self):
        print self.sendIt
    
    def _backend_behaviour_updateClients_main_enter(self):
        self.addTimer(0, 0.05)
        self.addTimer(1, 0.05)
        self.sendUpdate = False
        if(self.notifyChanged == True):
          if(self.counterClient < len(self.dataClient)):
            key = self.dataClient.keys()[self.counterClient]
            self.savedSource, savedParsedJson  = self.dataClient[key]
            self.response, self.sendUpdate = getResponseToUpdate(savedParsedJson, self.subject, self.savedSource)
            self.counterClient +=1
          else:
            self.notifyChanged = False
            self.counterClient = 0
    
    def _backend_behaviour_updateClients_main_exit(self):
        self.removeTimer(0)
        self.removeTimer(1)
    
    def _init_server_0_exec(self, parameters):
        instancename = parameters[0]
        self.big_step.outputEventOM(Event("start_instance", None, [self, instancename]))
    
    def _backend_behaviour_respondToClients_wait_for_requests_0_exec(self, parameters):
        source = parameters[0]
        data = parameters[1]
        logging.info("data received by BackEnd: "+data+" Source: "+source)
        print "data received by BackEnd: "+data+" Source: "+source
        self.source = source
        
        parsedJson = json.loads(data)
        
        requestName = parsedJson["request"]
        
        needUpdate = False
        
        
        if(requestName == "acceptData"):
          self.response = '{'
          self.sendIt = True
          option = parsedJson["option"]
          self.response += '"request": "response"'
          if(option == "input_text"):
            dataCell = str(parsedJson["data"])
            x = parsedJson["x"]
            y = parsedJson["y"]
            error = inputText(self.subject, x, y, dataCell)
            self.response += ','+'"badInput": "'+error+'"'
            self.response += ','+'"xError": "'+x+'"'
            self.response += ','+'"yError": "'+y+'"'
          elif(option in  ["copy", "past", "cut"]):
            xA = parsedJson["xA"]
            yA = parsedJson["yA"]
            xB = parsedJson["xB"]
            yB = parsedJson["yB"]
            if(option == "copy"):
              self.response += ','+'"response": "'+copy(self.subject, xA, yA, xB, yB)+'"'
            elif(option == "past"):
              self.response += ','+'"response": "'+past(self.subject, xA, yA, xB, yB)+'"'
            elif(option == "cut"):
              self.response += ','+'"response": "'+cut(self.subject, xA, yA, xB, yB)+'"'
          elif(option == "undo"):
            self.response += ','+'"response": "'+undo(self.subject)+'"'
          elif(option == "redo"):
            self.response += ','+'"response": "'+redo(self.subject)+'"'
          elif(option == "save"):
            fileName =  parsedJson["fileName"]
            self.response += ','+'"response": "'+save(self.subject, fileName)+'"'
          elif(option == "load"):
            fileName =  parsedJson["fileName"]
            self.response += ','+'"response": "'+load(self.subject, fileName)+'"'
          elif(option == "filesToLoad"):
            self.response += ','+'"response": '+getFilesToLoad()
          elif(option == "subscribe"):
            i = len(self.clientNames)
            name = "napoleon"+str(i)
            self.clientNames.append(name)
            self.response += ','+'"clientName": "'+name+'"'
            self.response += ','+'"connectionID": "'+self.source+'"'
          elif(option == "disconnect"):
            self.clientNames.remove(parsedJson['clientName'])
            del self.dataClient[parsedJson['clientName']]
            self.response += ','+'"response": "disconnected"'
        
          self.response += '}'
        
        elif(requestName == "update"):
          if(not(parsedJson['clientName'] in self.dataClient)):
            self.dataClient[parsedJson['clientName']] = [self.source, parsedJson]
            self.notifyChanged = True
          else:
            self.dataClient[parsedJson['clientName']] = [self.source, parsedJson]
        
        else:
          self.sendIt = True
          self.response = "{'request' :'unknown'}"
    
    def _backend_behaviour_respondToClients_processing_request_0_guard(self, parameters):
        return self.sendIt==False
    
    def _backend_behaviour_respondToClients_processing_request_1_exec(self, parameters):
        self.sendIt=False
        self.big_step.outputEventOM(Event("narrow_cast", None, [self, 'to_server/%s' % self.source, Event("HTTP_input", None, [self.response])]))
    
    def _backend_behaviour_respondToClients_processing_request_1_guard(self, parameters):
        return self.sendIt==True
    
    def _backend_behaviour_updateClients_main_0_exec(self, parameters):
        self.big_step.outputEventOM(Event("narrow_cast", None, [self, 'to_server/%s' % self.savedSource, Event("HTTP_input", None, [self.response])]))
    
    def _backend_behaviour_updateClients_main_0_guard(self, parameters):
        return self.sendUpdate == True
    
    def _backend_behaviour_updateClients_main_1_guard(self, parameters):
        return self.sendUpdate == False
    
    def initializeStatechart(self):
        # enter default state
        states = self.states["/init_server"].getEffectiveTargetStates()
        self.updateConfiguration(states)
        for state in states:
            if state.enter:
                state.enter()

class Server(RuntimeClassBase):
    def __init__(self, controller, address, port):
        RuntimeClassBase.__init__(self, controller)
        
        self.semantics.big_step_maximality = StatechartSemantics.TakeMany
        self.semantics.internal_event_lifeline = StatechartSemantics.Queue
        self.semantics.input_event_lifeline = StatechartSemantics.FirstComboStep
        self.semantics.priority = StatechartSemantics.SourceParent
        self.semantics.concurrency = StatechartSemantics.Single
        
        # build Statechart structure
        self.build_statechart_structure()
        
        # call user defined constructor
        Server.user_defined_constructor(self, address, port)
    
    def user_defined_constructor(self, address, port):
        self.socket = None
        self.address = address
        self.port = port
    
    def user_defined_destructor(self):
        pass
    
    
    # builds Statechart structure
    def build_statechart_structure(self):
        
        # state <root>
        self.states[""] = State(0, self)
        
        # state /main
        self.states["/main"] = ParallelState(1, self)
        
        # state /main/forward
        self.states["/main/forward"] = State(2, self)
        
        # state /main/forward/forward
        self.states["/main/forward/forward"] = State(3, self)
        
        # state /main/send_page
        self.states["/main/send_page"] = State(4, self)
        
        # state /main/send_page/waiting_for_page_request
        self.states["/main/send_page/waiting_for_page_request"] = State(5, self)
        
        # state /main/send_page/sendingPage
        self.states["/main/send_page/sendingPage"] = State(6, self)
        
        # state /main/server
        self.states["/main/server"] = State(7, self)
        
        # state /main/server/init
        self.states["/main/server/init"] = State(8, self)
        self.states["/main/server/init"].setEnter(self._main_server_init_enter)
        
        # state /main/server/binding
        self.states["/main/server/binding"] = State(9, self)
        self.states["/main/server/binding"].setEnter(self._main_server_binding_enter)
        
        # state /main/server/listening
        self.states["/main/server/listening"] = State(10, self)
        self.states["/main/server/listening"].setEnter(self._main_server_listening_enter)
        
        # state /main/server/accepting
        self.states["/main/server/accepting"] = State(11, self)
        
        # state /main/close_socket
        self.states["/main/close_socket"] = State(12, self)
        
        # state /main/close_socket/close
        self.states["/main/close_socket/close"] = State(13, self)
        
        # add children
        self.states[""].addChild(self.states["/main"])
        self.states["/main"].addChild(self.states["/main/forward"])
        self.states["/main"].addChild(self.states["/main/send_page"])
        self.states["/main"].addChild(self.states["/main/server"])
        self.states["/main"].addChild(self.states["/main/close_socket"])
        self.states["/main/forward"].addChild(self.states["/main/forward/forward"])
        self.states["/main/send_page"].addChild(self.states["/main/send_page/waiting_for_page_request"])
        self.states["/main/send_page"].addChild(self.states["/main/send_page/sendingPage"])
        self.states["/main/server"].addChild(self.states["/main/server/init"])
        self.states["/main/server"].addChild(self.states["/main/server/binding"])
        self.states["/main/server"].addChild(self.states["/main/server/listening"])
        self.states["/main/server"].addChild(self.states["/main/server/accepting"])
        self.states["/main/close_socket"].addChild(self.states["/main/close_socket/close"])
        self.states[""].fixTree()
        self.states[""].default_state = self.states["/main"]
        self.states["/main/forward"].default_state = self.states["/main/forward/forward"]
        self.states["/main/send_page"].default_state = self.states["/main/send_page/waiting_for_page_request"]
        self.states["/main/server"].default_state = self.states["/main/server/init"]
        self.states["/main/close_socket"].default_state = self.states["/main/close_socket/close"]
        
        # transition /main/forward/forward
        _main_forward_forward_0 = Transition(self, self.states["/main/forward/forward"], [self.states["/main/forward/forward"]])
        _main_forward_forward_0.setAction(self._main_forward_forward_0_exec)
        _main_forward_forward_0.trigger = Event("HTTP_output", None)
        self.states["/main/forward/forward"].addTransition(_main_forward_forward_0)
        
        # transition /main/send_page/waiting_for_page_request
        _main_send_page_waiting_for_page_request_0 = Transition(self, self.states["/main/send_page/waiting_for_page_request"], [self.states["/main/send_page/sendingPage"]])
        _main_send_page_waiting_for_page_request_0.setAction(self._main_send_page_waiting_for_page_request_0_exec)
        _main_send_page_waiting_for_page_request_0.trigger = Event("page_request", None)
        self.states["/main/send_page/waiting_for_page_request"].addTransition(_main_send_page_waiting_for_page_request_0)
        
        # transition /main/send_page/sendingPage
        _main_send_page_sendingPage_0 = Transition(self, self.states["/main/send_page/sendingPage"], [self.states["/main/send_page/waiting_for_page_request"]])
        _main_send_page_sendingPage_0.setAction(self._main_send_page_sendingPage_0_exec)
        _main_send_page_sendingPage_0.trigger = Event("page_received", None)
        self.states["/main/send_page/sendingPage"].addTransition(_main_send_page_sendingPage_0)
        
        # transition /main/server/init
        _main_server_init_0 = Transition(self, self.states["/main/server/init"], [self.states["/main/server/binding"]])
        _main_server_init_0.setAction(self._main_server_init_0_exec)
        _main_server_init_0.trigger = Event("created_socket", "socket_in")
        self.states["/main/server/init"].addTransition(_main_server_init_0)
        
        # transition /main/server/binding
        _main_server_binding_0 = Transition(self, self.states["/main/server/binding"], [self.states["/main/server/listening"]])
        _main_server_binding_0.trigger = Event("bound_socket", "socket_in")
        _main_server_binding_0.setGuard(self._main_server_binding_0_guard)
        self.states["/main/server/binding"].addTransition(_main_server_binding_0)
        
        # transition /main/server/listening
        _main_server_listening_0 = Transition(self, self.states["/main/server/listening"], [self.states["/main/server/accepting"]])
        _main_server_listening_0.setAction(self._main_server_listening_0_exec)
        _main_server_listening_0.trigger = Event("listened_socket", "socket_in")
        _main_server_listening_0.setGuard(self._main_server_listening_0_guard)
        self.states["/main/server/listening"].addTransition(_main_server_listening_0)
        
        # transition /main/server/accepting
        _main_server_accepting_0 = Transition(self, self.states["/main/server/accepting"], [self.states["/main/server/accepting"]])
        _main_server_accepting_0.setAction(self._main_server_accepting_0_exec)
        _main_server_accepting_0.trigger = Event("accepted_socket", "socket_in")
        self.states["/main/server/accepting"].addTransition(_main_server_accepting_0)
        _main_server_accepting_1 = Transition(self, self.states["/main/server/accepting"], [self.states["/main/server/accepting"]])
        _main_server_accepting_1.setAction(self._main_server_accepting_1_exec)
        _main_server_accepting_1.trigger = Event("instance_created", None)
        self.states["/main/server/accepting"].addTransition(_main_server_accepting_1)
        
        # transition /main/close_socket/close
        _main_close_socket_close_0 = Transition(self, self.states["/main/close_socket/close"], [self.states["/main/close_socket/close"]])
        _main_close_socket_close_0.setAction(self._main_close_socket_close_0_exec)
        _main_close_socket_close_0.trigger = Event("close_socket", None)
        self.states["/main/close_socket/close"].addTransition(_main_close_socket_close_0)
    
    def _main_server_init_enter(self):
        self.big_step.outputEvent(Event("create_socket", "socket_out", []))
    
    def _main_server_binding_enter(self):
        self.big_step.outputEvent(Event("bind_socket", "socket_out", [self.socket, (self.address, self.port)]))
    
    def _main_server_listening_enter(self):
        self.big_step.outputEvent(Event("listen_socket", "socket_out", [self.socket]))
    
    def _main_forward_forward_0_exec(self, parameters):
        association_name = parameters[0]
        data = parameters[1]
        self.big_step.outputEventOM(Event("narrow_cast", None, [self, 'parent', Event("HTTP_output", None, [association_name, data])]))
    
    def _main_send_page_waiting_for_page_request_0_exec(self, parameters):
        association_name = parameters[0]
        pageName = parameters[1]
        print "Server: we received a page request: " + pageName
        if(pageName == "favicon.ico"):
          pageName = "client/favicon.ico"
        file = open(pageName, 'r')
        data = file.read()
        file.close()
        self.big_step.outputEventOM(Event("narrow_cast", None, [self, association_name, Event("page_input", None, [data, pageName])]))
    
    def _main_send_page_sendingPage_0_exec(self, parameters):
        pageName = parameters[0]
        print "page sent: " + pageName
    
    def _main_server_init_0_exec(self, parameters):
        socket = parameters[0]
        self.socket = socket
    
    def _main_server_binding_0_guard(self, parameters):
        socket = parameters[0]
        return self.socket == socket
    
    def _main_server_listening_0_exec(self, parameters):
        socket = parameters[0]
        self.big_step.outputEvent(Event("accept_socket", "socket_out", [self.socket]))
    
    def _main_server_listening_0_guard(self, parameters):
        socket = parameters[0]
        return self.socket == socket
    
    def _main_server_accepting_0_exec(self, parameters):
        socket = parameters[0]
        connected_socket = parameters[1]
        self.big_step.outputEventOM(Event("create_instance", None, [self, 'sockets', 'Socket', connected_socket]))
        self.big_step.outputEvent(Event("accept_socket", "socket_out", [self.socket]))
    
    def _main_server_accepting_1_exec(self, parameters):
        instancename = parameters[0]
        self.big_step.outputEventOM(Event("start_instance", None, [self, instancename]))
        self.big_step.outputEventOM(Event("narrow_cast", None, [self, instancename, Event("set_association_name", None, [instancename])]))
    
    def _main_close_socket_close_0_exec(self, parameters):
        association_name = parameters[0]
        print "socket:", association_name, "is closed"
        self.big_step.outputEventOM(Event("delete_instance", None, [self, association_name]))
    
    def initializeStatechart(self):
        # enter default state
        states = self.states["/main"].getEffectiveTargetStates()
        self.updateConfiguration(states)
        for state in states:
            if state.enter:
                state.enter()

class Socket(RuntimeClassBase):
    def __init__(self, controller, my_socket):
        RuntimeClassBase.__init__(self, controller)
        
        self.semantics.big_step_maximality = StatechartSemantics.TakeMany
        self.semantics.internal_event_lifeline = StatechartSemantics.Queue
        self.semantics.input_event_lifeline = StatechartSemantics.FirstComboStep
        self.semantics.priority = StatechartSemantics.SourceParent
        self.semantics.concurrency = StatechartSemantics.Single
        
        # build Statechart structure
        self.build_statechart_structure()
        
        # call user defined constructor
        Socket.user_defined_constructor(self, my_socket)
    
    def user_defined_constructor(self, my_socket):
        self.socket = my_socket
        self.received_data = ""
        self.send_data = ""
        self.closed = False
        self.association_name = None
    
    def user_defined_destructor(self):
        pass
    
    
    # builds Statechart structure
    def build_statechart_structure(self):
        
        # state <root>
        self.states[""] = State(0, self)
        
        # state /init
        self.states["/init"] = State(1, self)
        
        # state /connected
        self.states["/connected"] = ParallelState(2, self)
        
        # state /connected/listening
        self.states["/connected/listening"] = State(3, self)
        
        # state /connected/listening/listen
        self.states["/connected/listening/listen"] = State(4, self)
        self.states["/connected/listening/listen"].setEnter(self._connected_listening_listen_enter)
        
        # state /connected/listening/closed
        self.states["/connected/listening/closed"] = State(5, self)
        self.states["/connected/listening/closed"].setEnter(self._connected_listening_closed_enter)
        
        # state /connected/sending
        self.states["/connected/sending"] = State(6, self)
        
        # state /connected/sending/waiting_for_data
        self.states["/connected/sending/waiting_for_data"] = State(7, self)
        
        # state /connected/sending/transferring
        self.states["/connected/sending/transferring"] = State(8, self)
        
        # state /connected/queueing
        self.states["/connected/queueing"] = State(9, self)
        
        # state /connected/queueing/queueing
        self.states["/connected/queueing/queueing"] = State(10, self)
        
        # state /connected/parsing
        self.states["/connected/parsing"] = State(11, self)
        
        # state /connected/parsing/wait_for_header
        self.states["/connected/parsing/wait_for_header"] = State(12, self)
        
        # state /connected/parsing/closing
        self.states["/connected/parsing/closing"] = State(13, self)
        self.states["/connected/parsing/closing"].setEnter(self._connected_parsing_closing_enter)
        self.states["/connected/parsing/closing"].setExit(self._connected_parsing_closing_exit)
        
        # state /connected/parsing/wait_for_payload_GET_page
        self.states["/connected/parsing/wait_for_payload_GET_page"] = State(14, self)
        
        # state /connected/parsing/wait_for_payload_POST
        self.states["/connected/parsing/wait_for_payload_POST"] = State(15, self)
        
        # state /close
        self.states["/close"] = State(16, self)
        self.states["/close"].setEnter(self._close_enter)
        
        # add children
        self.states[""].addChild(self.states["/init"])
        self.states[""].addChild(self.states["/connected"])
        self.states[""].addChild(self.states["/close"])
        self.states["/connected"].addChild(self.states["/connected/listening"])
        self.states["/connected"].addChild(self.states["/connected/sending"])
        self.states["/connected"].addChild(self.states["/connected/queueing"])
        self.states["/connected"].addChild(self.states["/connected/parsing"])
        self.states["/connected/listening"].addChild(self.states["/connected/listening/listen"])
        self.states["/connected/listening"].addChild(self.states["/connected/listening/closed"])
        self.states["/connected/sending"].addChild(self.states["/connected/sending/waiting_for_data"])
        self.states["/connected/sending"].addChild(self.states["/connected/sending/transferring"])
        self.states["/connected/queueing"].addChild(self.states["/connected/queueing/queueing"])
        self.states["/connected/parsing"].addChild(self.states["/connected/parsing/wait_for_header"])
        self.states["/connected/parsing"].addChild(self.states["/connected/parsing/closing"])
        self.states["/connected/parsing"].addChild(self.states["/connected/parsing/wait_for_payload_GET_page"])
        self.states["/connected/parsing"].addChild(self.states["/connected/parsing/wait_for_payload_POST"])
        self.states[""].fixTree()
        self.states[""].default_state = self.states["/init"]
        self.states["/connected/listening"].default_state = self.states["/connected/listening/listen"]
        self.states["/connected/sending"].default_state = self.states["/connected/sending/waiting_for_data"]
        self.states["/connected/queueing"].default_state = self.states["/connected/queueing/queueing"]
        self.states["/connected/parsing"].default_state = self.states["/connected/parsing/wait_for_header"]
        
        # transition /init
        _init_0 = Transition(self, self.states["/init"], [self.states["/connected"]])
        _init_0.setAction(self._init_0_exec)
        _init_0.trigger = Event("set_association_name", None)
        self.states["/init"].addTransition(_init_0)
        
        # transition /connected/listening/listen
        _connected_listening_listen_0 = Transition(self, self.states["/connected/listening/listen"], [self.states["/connected/listening/listen"]])
        _connected_listening_listen_0.setAction(self._connected_listening_listen_0_exec)
        _connected_listening_listen_0.trigger = Event("received_socket", "socket_in")
        _connected_listening_listen_0.setGuard(self._connected_listening_listen_0_guard)
        self.states["/connected/listening/listen"].addTransition(_connected_listening_listen_0)
        _connected_listening_listen_1 = Transition(self, self.states["/connected/listening/listen"], [self.states["/connected/listening/closed"]])
        _connected_listening_listen_1.setAction(self._connected_listening_listen_1_exec)
        _connected_listening_listen_1.trigger = Event("received_socket", "socket_in")
        _connected_listening_listen_1.setGuard(self._connected_listening_listen_1_guard)
        self.states["/connected/listening/listen"].addTransition(_connected_listening_listen_1)
        
        # transition /connected/sending/waiting_for_data
        _connected_sending_waiting_for_data_0 = Transition(self, self.states["/connected/sending/waiting_for_data"], [self.states["/connected/sending/transferring"]])
        _connected_sending_waiting_for_data_0.setAction(self._connected_sending_waiting_for_data_0_exec)
        _connected_sending_waiting_for_data_0.trigger = Event("send_data", None)
        _connected_sending_waiting_for_data_0.setGuard(self._connected_sending_waiting_for_data_0_guard)
        self.states["/connected/sending/waiting_for_data"].addTransition(_connected_sending_waiting_for_data_0)
        
        # transition /connected/sending/transferring
        _connected_sending_transferring_0 = Transition(self, self.states["/connected/sending/transferring"], [self.states["/connected/sending/waiting_for_data"]])
        _connected_sending_transferring_0.setAction(self._connected_sending_transferring_0_exec)
        _connected_sending_transferring_0.trigger = Event("sent_socket", "socket_in")
        _connected_sending_transferring_0.setGuard(self._connected_sending_transferring_0_guard)
        self.states["/connected/sending/transferring"].addTransition(_connected_sending_transferring_0)
        
        # transition /connected/queueing/queueing
        _connected_queueing_queueing_0 = Transition(self, self.states["/connected/queueing/queueing"], [self.states["/connected/queueing/queueing"]])
        _connected_queueing_queueing_0.setAction(self._connected_queueing_queueing_0_exec)
        _connected_queueing_queueing_0.trigger = Event("HTTP_input", None)
        self.states["/connected/queueing/queueing"].addTransition(_connected_queueing_queueing_0)
        _connected_queueing_queueing_1 = Transition(self, self.states["/connected/queueing/queueing"], [self.states["/connected/queueing/queueing"]])
        _connected_queueing_queueing_1.setAction(self._connected_queueing_queueing_1_exec)
        _connected_queueing_queueing_1.trigger = Event("page_input", None)
        self.states["/connected/queueing/queueing"].addTransition(_connected_queueing_queueing_1)
        
        # transition /connected/parsing/wait_for_header
        _connected_parsing_wait_for_header_0 = Transition(self, self.states["/connected/parsing/wait_for_header"], [self.states["/connected/parsing/wait_for_payload_POST"]])
        _connected_parsing_wait_for_header_0.setAction(self._connected_parsing_wait_for_header_0_exec)
        _connected_parsing_wait_for_header_0.setGuard(self._connected_parsing_wait_for_header_0_guard)
        self.states["/connected/parsing/wait_for_header"].addTransition(_connected_parsing_wait_for_header_0)
        _connected_parsing_wait_for_header_1 = Transition(self, self.states["/connected/parsing/wait_for_header"], [self.states["/connected/parsing/wait_for_payload_GET_page"]])
        _connected_parsing_wait_for_header_1.setGuard(self._connected_parsing_wait_for_header_1_guard)
        self.states["/connected/parsing/wait_for_header"].addTransition(_connected_parsing_wait_for_header_1)
        _connected_parsing_wait_for_header_2 = Transition(self, self.states["/connected/parsing/wait_for_header"], [self.states["/connected/parsing/closing"]])
        _connected_parsing_wait_for_header_2.setGuard(self._connected_parsing_wait_for_header_2_guard)
        self.states["/connected/parsing/wait_for_header"].addTransition(_connected_parsing_wait_for_header_2)
        
        # transition /connected/parsing/closing
        _connected_parsing_closing_0 = Transition(self, self.states["/connected/parsing/closing"], [self.states["/connected/parsing/closing"]])
        _connected_parsing_closing_0.setAction(self._connected_parsing_closing_0_exec)
        _connected_parsing_closing_0.trigger = Event("_0after")
        self.states["/connected/parsing/closing"].addTransition(_connected_parsing_closing_0)
        
        # transition /connected/parsing/wait_for_payload_GET_page
        _connected_parsing_wait_for_payload_GET_page_0 = Transition(self, self.states["/connected/parsing/wait_for_payload_GET_page"], [self.states["/connected/parsing/wait_for_header"]])
        _connected_parsing_wait_for_payload_GET_page_0.setAction(self._connected_parsing_wait_for_payload_GET_page_0_exec)
        self.states["/connected/parsing/wait_for_payload_GET_page"].addTransition(_connected_parsing_wait_for_payload_GET_page_0)
        
        # transition /connected/parsing/wait_for_payload_POST
        _connected_parsing_wait_for_payload_POST_0 = Transition(self, self.states["/connected/parsing/wait_for_payload_POST"], [self.states["/connected/parsing/wait_for_header"]])
        _connected_parsing_wait_for_payload_POST_0.setAction(self._connected_parsing_wait_for_payload_POST_0_exec)
        _connected_parsing_wait_for_payload_POST_0.setGuard(self._connected_parsing_wait_for_payload_POST_0_guard)
        self.states["/connected/parsing/wait_for_payload_POST"].addTransition(_connected_parsing_wait_for_payload_POST_0)
        
        # transition /connected
        _connected_0 = Transition(self, self.states["/connected"], [self.states["/close"]])
        _connected_0.trigger = Event("close", None)
        self.states["/connected"].addTransition(_connected_0)
    
    def _connected_listening_listen_enter(self):
        self.big_step.outputEvent(Event("recv_socket", "socket_out", [self.socket]))
    
    def _connected_listening_closed_enter(self):
        self.closed = True
    
    def _connected_parsing_closing_enter(self):
        self.addTimer(0, 12.0)
    
    def _connected_parsing_closing_exit(self):
        self.removeTimer(0)
    
    def _close_enter(self):
        self.big_step.outputEvent(Event("close_socket", "socket_out", [self.socket]))
        self.big_step.outputEventOM(Event("narrow_cast", None, [self, 'parent', Event("close_socket", None, [self.association_name])]))
    
    def _init_0_exec(self, parameters):
        association_name = parameters[0]
        self.association_name = association_name
    
    def _connected_listening_listen_0_exec(self, parameters):
        socket = parameters[0]
        data = parameters[1]
        self.received_data += data
        self.raiseInternalEvent(Event("received_data", None, []))
    
    def _connected_listening_listen_0_guard(self, parameters):
        socket = parameters[0]
        data = parameters[1]
        return (self.socket == socket) and (len(data) > 0)
    
    def _connected_listening_listen_1_exec(self, parameters):
        socket = parameters[0]
        data = parameters[1]
        self.raiseInternalEvent(Event("received_data", None, []))
    
    def _connected_listening_listen_1_guard(self, parameters):
        socket = parameters[0]
        data = parameters[1]
        return (self.socket == socket) and (len(data) == 0)
    
    def _connected_sending_waiting_for_data_0_exec(self, parameters):
        self.big_step.outputEvent(Event("send_socket", "socket_out", [self.socket, self.send_data]))
    
    def _connected_sending_waiting_for_data_0_guard(self, parameters):
        return len(self.send_data) > 0
    
    def _connected_sending_transferring_0_exec(self, parameters):
        socket = parameters[0]
        sent_bytes = parameters[1]
        self.send_data = self.send_data[sent_bytes:]
        print "data left: "+ str(len(self.send_data))
    
    def _connected_sending_transferring_0_guard(self, parameters):
        socket = parameters[0]
        sent_bytes = parameters[1]
        return self.socket == socket
    
    def _connected_queueing_queueing_0_exec(self, parameters):
        data = parameters[0]
        #post_data = "&amp;".join(["%s=%s" % (urllib.quote(k), urllib.quote(v)) for k, v in data.iteritems()])
        #post_data = "&amp;".join(["%s=%s" % (k, v) for k, v in data.iteritems()])
        post_data = data
        self.send_data += "HTTP/1.0 200 OK\r\n"
        self.send_data += "Content-Length: %s\r\n" % len(post_data)
        self.send_data += "Connection: keep-alive\r\n"
        self.send_data += "Content-Type: %s; charset=UTF-8\r\n" % "text/plain"
        self.send_data += "\r\n"
        self.send_data += str(post_data)
        
        print "Data sent:"
        print data + "to :" + self.association_name
        self.raiseInternalEvent(Event("send_data", None, []))
    
    def _connected_queueing_queueing_1_exec(self, parameters):
        data = parameters[0]
        pageName = parameters[1]
        #post_data = "&amp;".join(["%s=%s" % (urllib.quote(k), urllib.quote(v)) for k, v in data.iteritems()])
        #post_data = "&amp;".join(["%s=%s" % (k, v) for k, v in data.iteritems()])
        post_data = data
        self.send_data += "HTTP/1.0 200 OK\r\n"
        self.send_data += "Connection: keep-alive\r\n"
        self.send_data += "Content-Length: %s\r\n" % len(post_data)
        #self.send_data += "Cache-Control: max-age=3600, public\r\n"
        self.send_data += "Content-Type: %s; charset=UTF-8\r\n" % "text/html"
        self.send_data += "\r\n"
        self.send_data += str(post_data)
        self.raiseInternalEvent(Event("send_data", None, []))
        self.big_step.outputEventOM(Event("narrow_cast", None, [self, 'parent', Event("page_received", None, [pageName])]))
    
    def _connected_parsing_wait_for_header_0_exec(self, parameters):
        header, self.received_data = self.received_data.split("\r\n\r\n", 1)
        header = header.lower()
        if "content-length" in header:
            _, after = header.split("content-length:", 1)
            after = after.split("\r\n", 1)[0]
            after = after.strip()
            self.length = int(after)
        else:
            self.length = float('inf')
    
    def _connected_parsing_wait_for_header_0_guard(self, parameters):
        return '\r\n\r\n' in self.received_data and self.received_data.startswith('POST')
    
    def _connected_parsing_wait_for_header_1_guard(self, parameters):
        return '\r\n\r\n' in self.received_data and self.received_data.startswith('GET')
    
    def _connected_parsing_wait_for_header_2_guard(self, parameters):
        return self.closed and len(self.received_data) == 0
    
    def _connected_parsing_closing_0_exec(self, parameters):
        self.raiseInternalEvent(Event("close", None, []))
    
    def _connected_parsing_wait_for_payload_GET_page_0_exec(self, parameters):
        lines = self.received_data.split()
        lineGetRequest = lines[1]
        pageName = lineGetRequest.strip('/')
        self.received_data = ""
        self.big_step.outputEventOM(Event("narrow_cast", None, [self, 'parent', Event("page_request", None, [self.association_name, pageName])]))
    
    def _connected_parsing_wait_for_payload_POST_0_exec(self, parameters):
        if self.length == float('inf'):
            data = self.received_data
            self.received_data = ""
        else:
            data = self.received_data[:self.length]
            self.received_data = self.received_data[self.length:]
        
        # We support POST data only, so everything is in the data
        #try:
        #    params = dict([p.split('=') for p in data.split('&')])
        #    data = {k: urllib.unquote_plus(v) for k, v in params.iteritems()}
        #except:
        #    data = {}
        self.big_step.outputEventOM(Event("narrow_cast", None, [self, 'parent', Event("HTTP_output", None, [self.association_name, data])]))
    
    def _connected_parsing_wait_for_payload_POST_0_guard(self, parameters):
        return len(self.received_data) >= self.length or self.closed
    
    def initializeStatechart(self):
        # enter default state
        states = self.states["/init"].getEffectiveTargetStates()
        self.updateConfiguration(states)
        for state in states:
            if state.enter:
                state.enter()

class ObjectManager(ObjectManagerBase):
    def __init__(self, controller):
        ObjectManagerBase.__init__(self, controller)
    
    def instantiate(self, class_name, construct_params):
        if class_name == "BackEnd":
            instance = BackEnd(self.controller, construct_params[0])
            instance.associations = {}
            instance.associations["to_server"] = Association("Server", 1, 1)
        elif class_name == "Server":
            instance = Server(self.controller, construct_params[0], construct_params[1])
            instance.associations = {}
            instance.associations["sockets"] = Association("Socket", 0, -1)
            instance.associations["parent"] = Association("BackEnd", 1, 1)
        elif class_name == "Socket":
            instance = Socket(self.controller, construct_params[0])
            instance.associations = {}
            instance.associations["parent"] = Association("Server", 1, 1)
        else:
            raise Exception("Cannot instantiate class " + class_name)
        return instance

class Controller(ThreadsControllerBase):
    def __init__(self, params, keep_running = None):
        if keep_running == None: keep_running = True
        ThreadsControllerBase.__init__(self, ObjectManager(self), keep_running)
        self.addInputPort("socket_in")
        self.addOutputPort("socket_out")
        self.object_manager.createInstance("BackEnd", [params])